package com.gic.haoban.manage.service.service.out.impl;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.convert.Convert;
import cn.hutool.crypto.SecureUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.gic.api.base.commons.JSONResponse;
import com.gic.api.base.commons.Page;
import com.gic.clerk.api.dto.ClerkDTO;
import com.gic.clerk.api.service.ClerkService;
import com.gic.clerk.api.service.PowerService;
import com.gic.commons.util.DateUtil;
import com.gic.commons.util.EntityUtil;
import com.gic.commons.util.GICMQClientUtil;
import com.gic.dubbo.entity.ProviderLocalTag;
import com.gic.enterprise.api.dto.QRcodeDTO;
import com.gic.enterprise.api.dto.StoreDTO;
import com.gic.enterprise.api.service.ImageService;
import com.gic.enterprise.api.service.StoreService;
import com.gic.haoban.app.customer.dto.ChildDTO;
import com.gic.haoban.app.customer.dto.CustomerDTO;
import com.gic.haoban.app.customer.dto.FilterListDTO;
import com.gic.haoban.app.customer.dto.MemberInfoListParamsDTO;
import com.gic.haoban.app.customer.enums.GicQywxSyncTypeEnum;
import com.gic.haoban.app.customer.enums.QywxSyncTaskTypeEnum;
import com.gic.haoban.app.customer.service.api.service.CustomerApiService;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.base.api.common.ServiceResponse;
import com.gic.haoban.base.api.common.errCode.HaoBanErrCodeCommon;
import com.gic.haoban.common.utils.PageUtil;
import com.gic.haoban.manage.api.constants.Manage3Constants;
import com.gic.haoban.manage.api.dto.*;
import com.gic.haoban.manage.api.dto.qdto.hm.WxUserAddLogQDTO;
import com.gic.haoban.manage.api.enums.SecretTypeEnum;
import com.gic.haoban.manage.api.enums.WelcomeMediaTypeEnum;
import com.gic.haoban.manage.api.enums.hm.HmWelcomeReferType;
import com.gic.haoban.manage.api.service.CheckQywxSettingApiService;
import com.gic.haoban.manage.api.service.ExternalClerkRelatedApiService;
import com.gic.haoban.manage.api.service.MaterialApiService;
import com.gic.haoban.manage.api.service.MemberUnionidRelatedApiService;
import com.gic.haoban.manage.api.service.hm.HmQrcodeApiService;
import com.gic.haoban.manage.service.config.Config;
import com.gic.haoban.manage.service.dao.mapper.MemberUnionidRelatedMapper;
import com.gic.haoban.manage.service.dao.mapper.TabHaobanExternalClerkRelatedMapper;
import com.gic.haoban.manage.service.dao.mapper.WxApplicationMapper;
import com.gic.haoban.manage.service.entity.*;
import com.gic.haoban.manage.service.exception.WxApiLimitException;
import com.gic.haoban.manage.service.pojo.DealQywxExternalUserPojo;
import com.gic.haoban.manage.service.pojo.ExternalUserPojo;
import com.gic.haoban.manage.service.pojo.QywxTagSyncInfoPojo;
import com.gic.haoban.manage.service.pojo.bo.hm.KeyDataLinkBO;
import com.gic.haoban.manage.service.pojo.bo.welcome.WelcomeDetailBO;
import com.gic.haoban.manage.service.pojo.bo.welcome.WelcomeMediaBO;
import com.gic.haoban.manage.service.pojo.bo.welcome.WelcomeReferBO;
import com.gic.haoban.manage.service.service.*;
import com.gic.haoban.manage.service.service.hm.WxUserAddLogService;
import com.gic.haoban.manage.service.util.CommonUtil;
import com.gic.haoban.manage.service.util.EmojiFilterUtil;
import com.gic.member.api.dto.MemberDTO;
import com.gic.member.api.service.MemberApiService;
import com.gic.member.api.service.MemberOpenCardBusinessService;
import com.gic.member.api.service.MemberStoreService;
import com.gic.mq.sdk.GicMQClient;
import com.gic.redis.data.util.RedisUtil;
import com.gic.wechat.api.dto.qywx.*;
import com.gic.wechat.api.dto.qywx.welcome.*;
import com.gic.wechat.api.enums.QywxMediaTypeEnum;
import com.gic.wechat.api.service.qywx.QywxSuiteApiService;
import com.gic.wechat.api.service.qywx.QywxUserApiService;
import com.github.pagehelper.PageHelper;
import com.google.common.collect.Sets;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.redisson.api.RRateLimiter;
import org.redisson.api.RateIntervalUnit;
import org.redisson.api.RateType;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.concurrent.TimeUnit;
import java.util.stream.Collectors;

@Service
public class MemberUnionidRelatedApiServiceImpl implements MemberUnionidRelatedApiService {

    private static final Logger log = LogManager.getLogger(MemberUnionidRelatedApiServiceImpl.class);
    private static final String SELF_APP = "selfSuiteId";
    /**
     * 限制次数
     */
    private static final Integer MAX_TIMES = 5;

    @Autowired
    private MemberUnionRelatedService memberUnionRelatedService;
    @Autowired
    private StaffService staffService;
    @Autowired
    private QywxUserApiService qywxUserApiService;
    @Autowired
    private WxEnterpriseRelatedService wxEnterpriseRelatedService;
    @Autowired
    private WxEnterpriseService wxEnterpriseService;
    @Autowired
    private MemberOpenCardBusinessService memberOpenCardBusinessService;
    @Autowired
    private ClerkService clerkService;
    @Autowired
    private MemberUnionidRelatedMapper memberUnionidRelatedMapper;
    @Autowired
    private ClerkMainStoreRelatedService clerkMainStoreRelatedService;
    @Autowired
    private StoreService storeService;
    @Autowired
    private Config config;
    @Autowired
    private QywxSuiteApiService qywxSuiteApiService;
    @Autowired
    private MaterialApiService materialApiService;
    @Autowired
    private SecretSettingService secretSettingService;
    @Autowired
    private StaffClerkRelationService staffClerkRelationService;
    @Autowired
    private ExternalClerkRelatedService externalClerkRelatedService;
    @Autowired
    private PowerService powerService;
    @Autowired
    private MiniprogramSettingService miniprogramSettingService;
    @Autowired
    private WelcomeService welcomeService;
    @Autowired
    private CheckQywxSettingApiService checkQywxSettingApiService;
    @Autowired
    private CustomerApiService customerApiService;
    @Autowired
    private WxApplicationMapper wxApplicationMapper;
    @Autowired
    private MemberApiService memberApiService;
    @Autowired
    private TabHaobanExternalClerkRelatedMapper externalClerkRelatedMapper;
    @Autowired
    private ExternalClerkRelatedApiService externalClerkRelatedApiService;
    @Autowired
    private MemberStoreService memberStoreService;
    @Autowired
    private ImageService imageService;
    @Autowired
    private StaffDepartmentRelatedService staffDepartmentRelatedService;
    @Autowired
    private HmQrcodeApiService hmQrcodeApiService;
    @Autowired
    private WxUserAddLogService wxUserAddLogService;
    @Autowired
    private KeyDataService keyDataService;

    @Override
    public void dealQywxExternalUser(String params) {
        log.info("处理外部联系人回调：{}", params);
        DealQywxExternalUserPojo externalUserPojo = JSONObject.parseObject(params, DealQywxExternalUserPojo.class);
        if (externalUserPojo.getType() == DealQywxExternalUserPojo.DealType.del.getType()) {
            this.delMemberUnionidRelatedProcess(externalUserPojo.getData());
        } else if (externalUserPojo.getType() == DealQywxExternalUserPojo.DealType.add.getType()) {
            this.addMemberUnionidRelatedNew(externalUserPojo.getData());
        } else if (externalUserPojo.getType() == DealQywxExternalUserPojo.DealType.edit.getType()) {
            this.editMemberUnionidRelatedProcess(externalUserPojo.getData());
        }
    }

    @Override
    public List<MemberStoreDTO> listByExTernalUseridAndWxUserId(String externalUserid, String wxUserId, String storeId) {
        List<TabHaobanExternalClerkRelated> list = externalClerkRelatedService.listByExTernalUseridAndWxUserId(externalUserid, wxUserId);
        List<MemberStoreDTO> result = new ArrayList<>();
        if (CollectionUtil.isEmpty(list)) {
            return null;
        }
        String wxEnterpriseId = list.get(0).getWxEnterpriseId();
        TabHaobanStaff haobanStaff = staffService.selectByUserIdAndEnterpriseId(wxUserId, wxEnterpriseId);
        if (null == haobanStaff) {
            log.info("staff不存在");
            return null;
        }
        List<StaffClerkRelationDTO> clerkRelationDTOS = staffClerkRelationService.listBindCodeByStaffId(null, haobanStaff.getStaffId());
        if (CollectionUtil.isEmpty(clerkRelationDTOS)) {
            log.info("staff关联门店不存在1");
            return null;
        }
        List<String> storeIds = clerkRelationDTOS.stream().filter(s -> (s.getStoreId() != null || "".equals(s.getStoreId()))).map(s -> s.getStoreId()).collect(Collectors.toList());
        if (CollectionUtil.isEmpty(storeIds)) {
            log.info("staff关联门店不存在2");
            return null;
        }
        //2、获取member的storeId
        for (TabHaobanExternalClerkRelated tab : list) {
            if (StringUtils.isNotBlank(storeId) && (!storeId.equals(tab.getStoreId()))) {
                continue;
            }
            String memberId = tab.getMemberId();
            if (StringUtils.isEmpty(memberId)) {
                continue;
            }
            CustomerDTO params = new CustomerDTO();
            params.setClerkType("0");
            params.setStoreId(tab.getStoreId());
            params.setClerkId(tab.getClerkId());
            params.setEnterpriseId(tab.getEnterpriseId());
            params.setStoreManagerFlag(isManager(tab.getClerkId()));

            MemberInfoListParamsDTO memberInfoListParamsDTO = new MemberInfoListParamsDTO();
            memberInfoListParamsDTO.setMemberId(tab.getMemberId());

            FilterListDTO filterListDTO = new FilterListDTO();
            filterListDTO.setFilterType("4");
            ChildDTO childDTO = new ChildDTO();
            childDTO.setId("");
            filterListDTO.setChild(childDTO);
            List<FilterListDTO> filterList = new ArrayList<>();
            filterList.add(filterListDTO);

            memberInfoListParamsDTO.setFilterList(filterList);

            boolean flag = customerApiService.checkMemberRangeByMemberId(params, memberInfoListParamsDTO);
            MemberStoreDTO dto = new MemberStoreDTO();
            dto.setMemberId(tab.getMemberId());
            dto.setStoreId(tab.getStoreId());
            if (flag) {
                dto.setHasRight(1);
            } else {
                dto.setHasRight(0);
            }
            result.add(dto);
        }
        return result;
    }

    private boolean isManager(String clerkId) {
        ClerkDTO clerkDTO = clerkService.getclerkById(clerkId);
        if (clerkDTO != null) {
            Integer isManager = clerkDTO.getClerkType();
            return isManager != null && isManager == 1 && clerkDTO.getStatus() == 1;
        }
        return false;
    }

    /**
     * 根据导购导购微信id和会员id查询关联关系
     *
     * @return : 返回关联关系
     */
    @Override
    public ExternalClerkRelatedDTO getByWxUserIdMemberId(String wxUserId, String memberId) {
        return externalClerkRelatedService.getByMemberId(wxUserId, memberId);
    }

    @Override
    public MemberUnionidRelatedDTO getByUnionId(String staffId, String unionid) {
        TabHaobanStaff staff = staffService.selectById(staffId);
        if (staff == null) {
            return null;
        }
        log.info("【查询会员】wxUserId={},unionid={}", staff.getWxUserId(), unionid);
        return memberUnionRelatedService.getByWxUserIdAndUnionId(staff.getWxEnterpriseId(), staff.getWxUserId(), unionid);
    }

    @Override
    public String addMemberUnionidRelated(MemberUnionidRelatedDTO dto) {
        DealQywxExternalUserPojo dealQywxExternalUserPojo = new DealQywxExternalUserPojo();
        dealQywxExternalUserPojo.setType(DealQywxExternalUserPojo.DealType.add.getType());
        dealQywxExternalUserPojo.setData(dto);

        GicMQClient instance = GICMQClientUtil.getClientInstance();
        try {
            instance.sendMessage("dealQywxExternalUserMq", JSONObject.toJSONString(dealQywxExternalUserPojo));
        } catch (Exception e) {
            log.info("异步处理异常：{}", e);
        }
        return null;
    }


    @Override
    public String addMemberUnionidRelatedNew(MemberUnionidRelatedDTO dto) {
        //解析组装信息
        dto = getMemberUnionidRelatedDTONew(dto);
        if (null == dto) {
            log.info("没处理完成-等下一次处理");
            return null;
        }
        insertExternalClerkRelatedNew(dto);
        return dto.getMemberUnionidRelatedId();
    }

    /**
     * 创建关联关系
     *
     * @param dto
     */
    private void insertExternalClerkRelatedNew(MemberUnionidRelatedDTO dto) {
        log.info("新增外部联系人，创建关联关系：{}", JSON.toJSONString(dto));
        String wxUserId = dto.getWxUserId();
        String wxEnterpriseId = dto.getWxEnterpriseId();
        String name = dto.getExternalName();
        String createTime = dto.getAddCreateTime();
        String externalUserId = dto.getExternalUserid();
        String unionid = dto.getUnionid();
        String state = dto.getState();
        log.info("新增外部联系人,wxEnterpriseId:{}", wxEnterpriseId);
        if (StringUtils.isAnyBlank(wxUserId, wxEnterpriseId, name, createTime, externalUserId)) {
            log.error("新增外部联系人，缺少必须字段：wxUserId:{},wxEnterpriseId:{},name:{},createTime:{},externalUserId:{}", wxUserId, wxEnterpriseId, name, createTime, externalUserId);
            //checkQywxSettingApiService.saveFriendCallback(wxEnterpriseId,null,  dto);
            return;
        }
        TabHaobanStaff staff = staffService.selectByUserIdAndEnterpriseId(wxUserId, wxEnterpriseId);
        if (staff == null) {
            log.info("staff不存在：{},{}", dto.getUnionid(), dto.getWxUserId());
            return;
        }
        String staffId = staff.getStaffId();
        String staffWxUserId = staff.getWxUserId();
        log.info("新增外部联系人,staff.getWxUserId():{}", staffWxUserId);
        dto.setWxUserId(staffWxUserId);
        TabHaobanClerkMainStoreRelated mainStoreRelated = clerkMainStoreRelatedService.getMainStoreByStaffId(staffId, wxEnterpriseId);
        if (mainStoreRelated == null) {
            log.info("【新增外部联系人】主门店为空:{}", staffId);
            // 无主门店仅发送欢迎语
            sendWelcome(dto, wxEnterpriseId, null, staffId, null);
            return;
        }

        StaffClerkRelationDTO staffClerkRelationDTO = staffClerkRelationService.getOneBindByStoreId(staffId, mainStoreRelated.getStoreId());
        if (staffClerkRelationDTO == null) {
            log.info("【新增外部联系人】导购和clerk关联为空");
            return;
        }

        String enterpriseId = staffClerkRelationDTO.getEnterpriseId();
        String clerkId = staffClerkRelationDTO.getClerkId();
        TabHaobanWxEnterpriseRelated wxEnterpriseRelated = wxEnterpriseRelatedService.getByEnterpriseId(wxEnterpriseId, enterpriseId);
        if (wxEnterpriseRelated == null) {
            log.info("没有存在企业关联：{},{}", staffClerkRelationDTO.getWxEnterpriseId(), enterpriseId);
            return;
        }

        WxEnterpriseDTO wxEnterpriseDTO = wxEnterpriseService.selectById(wxEnterpriseId);
        if (wxEnterpriseDTO == null) {
            log.info("未查询到企业：wxEnterpriseId:{}", wxEnterpriseId);
            return;
        }

        //活码处理 "DT" "HM"
        Long refId = 0L;
        WxUserAddLogQDTO wxUserAddLogQDTO = new WxUserAddLogQDTO();
        if (StringUtils.isNotBlank(state) && StringUtils.isNotBlank(clerkId)) {
            String id = state.substring(2);
            if (state.contains("HM")) {
                //活码
                refId = Convert.toLong(id);
                wxUserAddLogQDTO.setHmId(refId);
                hmQrcodeApiService.updateAddNumById(Convert.toLong(id),clerkId);
            } else if (state.contains("DT")) {
                KeyDataLinkBO dataForHmLink = keyDataService.getDataForHmLink(id);
                refId = dataForHmLink.getLinkId();
                unionid = dataForHmLink.getUnionid();
                wxUserAddLogQDTO.setLinkId(refId);
                wxUserAddLogQDTO.setHmId(dataForHmLink.getHmId());
            }
        }

        String memberId = "";
        if (StringUtils.isNotBlank(unionid)) {
            log.info("有unionid处理：wxEnterpriseId:{}，unionid：{}", wxEnterpriseId,unionid);
            dto.setUnionid(unionid);
            memberId = addExternalClerkRelated(dto, staffId, staffClerkRelationDTO, wxEnterpriseRelated);
        } else {
            log.info("发送欢迎语逻辑：wxEnterpriseId:{}", wxEnterpriseId);
            addFriendByWelcome(dto, staffClerkRelationDTO);
        }

        log.info("插入加好友日志");
        wxUserAddLogService.updateMemberInfo(wxEnterpriseId,externalUserId,memberId);
    }

    /**
     * 根据统一开平和不同开平 处理不同的添加好友关系
     *
     * @param dto
     * @param staffId
     * @param staffClerkRelationDTO
     * @param wxEnterpriseRelated
     */
    private String addExternalClerkRelated(MemberUnionidRelatedDTO dto, String staffId, StaffClerkRelationDTO staffClerkRelationDTO, TabHaobanWxEnterpriseRelated wxEnterpriseRelated) {
        String wxUserId = dto.getWxUserId();
        String wxEnterpriseId = dto.getWxEnterpriseId();
        String name = dto.getExternalName();
        String createTime = dto.getAddCreateTime();
        String externalUserid = dto.getExternalUserid();
        String avatar = dto.getAvatar();
        if (wxEnterpriseRelated.getMemberOpenCardFlag() == 1) {
            log.info("不同开平，走欢迎语逻辑，wxEnterpriseId：{}", wxEnterpriseId);
            addFriendByWelcome(dto, staffClerkRelationDTO);
            return "";
        }
        log.info("同一开平，创建关联关系...");
        String unionId = dto.getUnionid();
        if (StringUtils.isBlank(unionId)) {
            log.info("unionid不存在,走发送欢迎语逻辑：wxEnterpriseId:{}", wxEnterpriseId);
            addFriendByWelcome(dto, staffClerkRelationDTO);
            return "";
        }
        //新增导购和外部联系人关系
        String clerkId = staffClerkRelationDTO.getClerkId();
        String clerkCode = staffClerkRelationDTO.getClerkCode();
        String enterpriseId = staffClerkRelationDTO.getEnterpriseId();
        ClerkDTO clerk = clerkService.getClerkByClerkCode(enterpriseId, clerkCode);
        log.info("【新增外部联系人】clerkCode={},unionid:{}", clerkCode, unionId);
        if (clerk == null) {
            log.info("【新增外部联系人】导购为空:{},{}", clerkCode, unionId);
            return "";
        }

        String qrcodeParam = clerk.getQrcodeParam();
        if (StringUtils.isBlank(qrcodeParam)) {
            powerService.saveClerkQrCode(clerk.getClerkId());
            clerk = clerkService.getClerkByClerkCode(enterpriseId, clerkCode);
            qrcodeParam = clerk.getQrcodeParam();
        }
        if (StringUtils.isBlank(qrcodeParam)) {
            log.info("不能生产导购二维码：{}", JSONObject.toJSONString(clerk));
            return "";
        }
        log.info("【新增外部联系人会员】enterpriseId={},unionId={},name={},avatar={},QrcodeParam={}", enterpriseId, unionId, name, avatar, qrcodeParam);
        MemberDTO member = memberOpenCardBusinessService.getMemberByQywxChannelParam(enterpriseId, unionId, "", name, avatar, qrcodeParam);
        if (member == null) {
            log.info("生产会员memnerid失败：{}", unionId);
            return "";
        }
        String memberId = member.getMemberId();
        List<TabHaobanExternalClerkRelated> externalClerkRelateds = externalClerkRelatedService.listByExTernalUseridAndWxUserIdAllStatus(wxEnterpriseId, externalUserid, dto.getWxUserId());
        String relationKey = SecureUtil.md5(staffId + externalUserid);
        if (CollectionUtils.isEmpty(externalClerkRelateds)) {
            log.info("新增TabHaobanExternalClerkRelated");
            TabHaobanExternalClerkRelated related = new TabHaobanExternalClerkRelated();
            related.setAddCreateTime(createTime);
            related.setClerkId(clerkId);
            related.setEnterpriseId(enterpriseId);
            related.setExternalName(name);
            related.setExternalUserId(externalUserid);
            related.setStaffId(staffId);
            related.setHeadUrl(dto.getAvatar());
            related.setMemberUnionidRelatedId(dto.getMemberUnionidRelatedId());
            related.setStoreId(staffClerkRelationDTO.getStoreId());
            related.setRelationKey(relationKey);
            related.setUnionid(unionId);
            related.setWxEnterpriseId(wxEnterpriseId);
            related.setWxUserId(wxUserId);
            related.setMemberId(memberId);
            externalClerkRelatedService.insert(related);
        } else {
            log.info("更新TabHaobanExternalClerkRelated");
            TabHaobanExternalClerkRelated exsitDTO = externalClerkRelateds.get(0);
            exsitDTO.setMemberId(memberId);
            exsitDTO.setMemberUnionidRelatedId(dto.getMemberUnionidRelatedId());
            exsitDTO.setExternalUserId(externalUserid);
            exsitDTO.setUnionid(unionId);
            exsitDTO.setRelationKey(relationKey);
            exsitDTO.setHeadUrl(dto.getAvatar());
            exsitDTO.setStoreId(staffClerkRelationDTO.getStoreId());
            exsitDTO.setEnterpriseId(enterpriseId);
            exsitDTO.setClerkId(clerkId);
            exsitDTO.setStatusFlag(1);
            externalClerkRelatedService.update(exsitDTO);
        }
        sendWelcome(dto, wxEnterpriseId, enterpriseId, staffId, clerkId);
        //同步好友标签
        pushTagSync(memberId, wxEnterpriseId, enterpriseId);
        //回调给会员，更新是否为企微好友
        log.info("通知会员 合并会员后更新为企微好友,memberId:{}", memberId);
        memberApiService.updateMemberQywxFlag(enterpriseId, memberId, 1);
        return memberId;
    }


    /**
     * 欢迎语新增好友
     *
     * @param dto
     */
    private void addFriendByWelcome(MemberUnionidRelatedDTO dto, StaffClerkRelationDTO staffClerkRelationDTO) {
        String staffId = staffClerkRelationDTO.getStaffId();
        String clerkId = staffClerkRelationDTO.getClerkId();
        String relationKey = SecureUtil.md5(staffId + dto.getExternalUserid());
        String wxEnterpriseId = staffClerkRelationDTO.getWxEnterpriseId();
        String enterpriseId = staffClerkRelationDTO.getEnterpriseId();
        //发送欢迎语
        sendWelcome(dto, wxEnterpriseId, enterpriseId, staffId, clerkId);

        //保存好友关系
        List<TabHaobanExternalClerkRelated> externalClerkRelateds = externalClerkRelatedService.listByExTernalUseridAndWxUserIdAllStatus(wxEnterpriseId, dto.getExternalUserid(), dto.getWxUserId());
        if (CollectionUtils.isEmpty(externalClerkRelateds)) {
            log.info("新增TabHaobanExternalClerkRelated");
            TabHaobanExternalClerkRelated related = new TabHaobanExternalClerkRelated();
            related.setAddCreateTime(dto.getAddCreateTime());
            related.setClerkId(staffClerkRelationDTO.getClerkId());
            related.setEnterpriseId(enterpriseId);
            related.setExternalName(dto.getExternalName());
            related.setExternalUserId(dto.getExternalUserid());
            related.setStaffId(staffId);
            related.setMemberUnionidRelatedId(dto.getMemberUnionidRelatedId());
            related.setStoreId(staffClerkRelationDTO.getStoreId());
            related.setRelationKey(relationKey);
            related.setStatusFlag(4);
            related.setPushTimes(1);
            related.setWxEnterpriseId(wxEnterpriseId);
            related.setWxUserId(dto.getWxUserId());
            related.setHeadUrl(dto.getAvatar());
            externalClerkRelatedService.insert(related);
        } else {
            log.info("更新TabHaobanExternalClerkRelated");
            TabHaobanExternalClerkRelated exsitDTO = externalClerkRelateds.get(0);
            exsitDTO.setMemberUnionidRelatedId(dto.getMemberUnionidRelatedId());
            exsitDTO.setExternalUserId(dto.getExternalUserid());
            exsitDTO.setStoreId(staffClerkRelationDTO.getStoreId());
            exsitDTO.setEnterpriseId(enterpriseId);
            exsitDTO.setClerkId(staffClerkRelationDTO.getClerkId());
            exsitDTO.setRelationKey(relationKey);
            exsitDTO.setHeadUrl(dto.getAvatar());
            exsitDTO.setStatusFlag(4);
            externalClerkRelatedService.update(exsitDTO);
        }

    }

    /**
     * 发送欢迎语
     *
     * @param dto
     * @param wxEnterpriseId
     * @param enterpriseId
     * @param staffId
     */
    private void sendWelcome(MemberUnionidRelatedDTO dto, String wxEnterpriseId, String enterpriseId, String staffId, String clerkId) {
        log.info("发送欢迎语：dto:{},wxEnterpriseId:{},staffId:{}", JSONObject.toJSONString(dto), wxEnterpriseId, staffId);
        String welcomeCode = dto.getWelcomeCode();
        String state = dto.getState();
        if (StringUtils.isBlank(welcomeCode)) {
            log.error("welcomeCode为空，请检查是否使用企微的欢迎语：{}", wxEnterpriseId);
            GicMQClient clientInstance = GICMQClientUtil.getClientInstance();
            try {
                QywxErrorLogDTO qywxErrorLogDTO = new QywxErrorLogDTO();
                qywxErrorLogDTO.setWxEnterpriseId(wxEnterpriseId);
                qywxErrorLogDTO.setCorpid(dto.getCorpid());
                qywxErrorLogDTO.setScenario("欢迎语不发送");
                qywxErrorLogDTO.setErrorContent("welcomeCode为空，请检查是否使用企微的欢迎语");
                qywxErrorLogDTO.setTraceId(ProviderLocalTag.tag.get().traceId);
                qywxErrorLogDTO.setQywxErrorType(1);
                clientInstance.sendMessage(Manage3Constants.QYWX_ERROR_MSG, JSON.toJSONString(qywxErrorLogDTO));
            } catch (Exception e) {
                log.error("发送消息失败：{}", e.getMessage(), e);
            }
            return;
        }
        String relationKey = SecureUtil.md5(staffId + dto.getExternalUserid());

        WelcomeDetailBO welcomeDetailBO = null;
        if (StringUtils.isNotBlank(state)) {
            //"HM+id" "DT+key"
            log.info("特殊欢迎语 state:{}", state);
            WelcomeReferBO welcomeReferBo = getWelcomeReferBo(state);
            welcomeDetailBO = welcomeService.getMatchWelcomeWithReferId(staffId, wxEnterpriseId, welcomeReferBo);
        } else {
            welcomeDetailBO = welcomeService.getMatchWelcome(staffId, wxEnterpriseId);
        }

        if (Objects.isNull(welcomeDetailBO)) {
            log.info("欢迎语未配置：wxEnterpriseId:{}", wxEnterpriseId);
            return;
        }
        WxEnterpriseDTO wxEnterpriseDTO = wxEnterpriseService.selectById(wxEnterpriseId);
        if (wxEnterpriseDTO == null) {
            log.info("微信企业不存在：wxEnterpriseId:{}", wxEnterpriseId);
            return;
        }
        //内容
        String content = welcomeDetailBO.getWelcomeContent().replaceAll("<微信昵称>", dto.getExternalName());
        QywxWelcomeMsgDTO qywxWelcomeMsgDTO = new QywxWelcomeMsgDTO();
        // 欢迎语内容
        qywxWelcomeMsgDTO.setText(content);
        //欢迎语类型
        List<QywxExternalMessageBaseDTO> attachments = new ArrayList<>();
        // 开始设置欢迎语附件
        List<WelcomeMediaBO> mediaList = welcomeDetailBO.getWelcomeMediaList();
        log.info("欢迎语发送附件list:{}", JSON.toJSONString(mediaList));
        mediaList.forEach(one -> {
            Integer mediaType = one.getMediaType();
            if (WelcomeMediaTypeEnum.IMAGE.getCode().equals(mediaType)) {
                attachmentAddImage(attachments, one, wxEnterpriseDTO);
            }
            if (WelcomeMediaTypeEnum.VIDEO.getCode().equals(mediaType)) {
                attachmentAddVideo(attachments, one, wxEnterpriseDTO);
            }
            if (WelcomeMediaTypeEnum.FILE.getCode().equals(mediaType)) {
                attachmentAddFile(attachments, one, wxEnterpriseDTO);
            }
            if (WelcomeMediaTypeEnum.LINK.getCode().equals(mediaType)) {
                attachmentAddLink(attachments, one);
            }
            if (WelcomeMediaTypeEnum.PROGRAM.getCode().equals(mediaType)) {
                attachmentAddProgram(attachments, one, wxEnterpriseId);
            }
            if (WelcomeMediaTypeEnum.PARAM_PROGRAM.getCode().equals(mediaType)) {
                attachmentAddParamProgram(attachments, enterpriseId, wxEnterpriseId, relationKey);
            }
            if (WelcomeMediaTypeEnum.PARAM_QRCODE.getCode().equals(mediaType)) {
                attachmentAddParamQrCode(attachments, enterpriseId, clerkId, wxEnterpriseDTO, relationKey);
            }
        });
        if (CollectionUtils.isNotEmpty(attachments)) {
            qywxWelcomeMsgDTO.setAttachments(attachments);
        }
        qywxWelcomeMsgDTO.setWelcomeCode(welcomeCode);
        log.info("[sendWelcome] 发送欢迎语 params:{}", JSON.toJSONString(qywxWelcomeMsgDTO));
        if (dto.getSuiteid().equals(SELF_APP)) {
            //好办助手和代开发
            SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(dto.getWxEnterpriseId(), SecretTypeEnum.HAOBAN_HELP.getVal());
            qywxUserApiService.sendSelfWelcomeMsgByExternal(dto.getCorpid(), secretSetting.getSecretVal(), qywxWelcomeMsgDTO);
        } else {
            qywxUserApiService.sendWelcomeMsgByExternal(dto.getCorpid(), config.getWxSuiteid(), qywxWelcomeMsgDTO);
        }
    }

    /**
     * 获取链接或者活码id
     * @param state
     * @return
     */
    private WelcomeReferBO getWelcomeReferBo(String state){
        WelcomeReferBO welcomeReferBo = new WelcomeReferBO();
        String id = state.substring(2);
        if (state.contains("HM")) {
            welcomeReferBo.setType(HmWelcomeReferType.HM.getCode());
            welcomeReferBo.setReferId(id);
        } else if (state.contains("DT")) {
            KeyDataLinkBO dataForHmLink = keyDataService.getDataForHmLink(id);
            if (dataForHmLink != null) {
                welcomeReferBo.setType(HmWelcomeReferType.LINK.getCode());
                welcomeReferBo.setReferId(Convert.toStr(dataForHmLink.getLinkId()));
            }
        }
        return welcomeReferBo;
    }

    private void attachmentAddImage(List<QywxExternalMessageBaseDTO> attachments, WelcomeMediaBO media, WxEnterpriseDTO wxEnterpriseDTO) {
        String mediaUrl = media.getMediaUrl();
        String[] arr = mediaUrl.split("/");
        JSONResponse jp = qywxSuiteApiService.uploadMedia(
                wxEnterpriseDTO.getCorpid(),
                config.getWxSuiteid(),
                CommonUtil.getFileByte(mediaUrl),
                arr[arr.length - 1],
                QywxMediaTypeEnum.IMAGE.getCode());
        log.info("欢迎语发送图片返回：{}", JSON.toJSONString(jp));
        if (jp.getErrorCode() == 0) {
            QywxImageExternalBaseDTO qywxImageExternalBaseDTO = new QywxImageExternalBaseDTO();
            qywxImageExternalBaseDTO.setMediaId(jp.getResult().toString());
            attachments.add(qywxImageExternalBaseDTO);
        }
    }

    private void attachmentAddVideo(List<QywxExternalMessageBaseDTO> attachments, WelcomeMediaBO media, WxEnterpriseDTO wxEnterpriseDTO) {
        String mediaUrl = media.getMediaUrl();
        String[] arr = mediaUrl.split("/");
        JSONResponse jp = qywxSuiteApiService.uploadMedia(
                wxEnterpriseDTO.getCorpid(),
                config.getWxSuiteid(),
                CommonUtil.getFileByte(mediaUrl),
                arr[arr.length - 1],
                QywxMediaTypeEnum.VIDEO.getCode());
        log.info("欢迎语发送视频返回：{}", JSON.toJSONString(jp));
        if (jp.getErrorCode() == 0) {
            QywxVideoExternalBaseDTO qywxVideoExternalBaseDTO = new QywxVideoExternalBaseDTO();
            qywxVideoExternalBaseDTO.setMediaId(jp.getResult().toString());
            attachments.add(qywxVideoExternalBaseDTO);
        }
    }

    private void attachmentAddFile(List<QywxExternalMessageBaseDTO> attachments, WelcomeMediaBO media, WxEnterpriseDTO wxEnterpriseDTO) {
        String mediaUrl = media.getMediaUrl();
        String[] arr = mediaUrl.split("/");
        JSONResponse jp = qywxSuiteApiService.uploadMedia(
                wxEnterpriseDTO.getCorpid(),
                config.getWxSuiteid(),
                CommonUtil.getFileByte(mediaUrl),
                arr[arr.length - 1],
                QywxMediaTypeEnum.FILE.getCode());
        log.info("欢迎语发送文件返回：{}", JSON.toJSONString(jp));
        if (jp.getErrorCode() == 0) {
            QywxFileExternalBaseDTO qywxFileExternalBaseDTO = new QywxFileExternalBaseDTO();
            qywxFileExternalBaseDTO.setMediaId(jp.getResult().toString());
            attachments.add(qywxFileExternalBaseDTO);
        }
    }

    private void attachmentAddLink(List<QywxExternalMessageBaseDTO> attachments, WelcomeMediaBO media) {
        String mediaTitle = media.getMediaTitle();
        String mediaUrl = media.getMediaUrl();
        QywxLinkExternalBaseDTO qywxLinkExternalBaseDTO = new QywxLinkExternalBaseDTO();
        qywxLinkExternalBaseDTO.setTitle(mediaTitle);
        qywxLinkExternalBaseDTO.setUrl(mediaUrl);
        attachments.add(qywxLinkExternalBaseDTO);
    }

    private void attachmentAddProgram(List<QywxExternalMessageBaseDTO> attachments, WelcomeMediaBO media, String wxEnterpriseId) {
        log.info("发送小程序：wxEnterpriseId:{}", wxEnterpriseId);
        String miniprogramSettingId = media.getMiniprogramSettingId();
        TabMiniprogramSetting miniprogramSetting = miniprogramSettingService.getById(miniprogramSettingId);
        if (Objects.isNull(miniprogramSetting) || miniprogramSetting.getStatusFlag() == 0) {
            log.info("小程序不存在或已被删除, miniprogramSettingId:{}", miniprogramSettingId);
            return;
        }
        QywxMiniprogramExternalBaseDTO messageBaseDTO = new QywxMiniprogramExternalBaseDTO();
        messageBaseDTO.setAppid(miniprogramSetting.getAppId());
        messageBaseDTO.setPicMediaId(miniprogramSetting.getMediaId());
        messageBaseDTO.setTitle(miniprogramSetting.getTitle());
        messageBaseDTO.setPage(media.getMiniProgramPage());
        attachments.add(messageBaseDTO);
    }

    private void attachmentAddParamProgram(List<QywxExternalMessageBaseDTO> attachments, String enterpriseId, String wxEnterpriseId, String relationKey) {
        if (StringUtils.isEmpty(enterpriseId) || StringUtils.isEmpty(relationKey)) {
            log.info("带参二维码无法发送");
            return;
        }
        log.info("发送带参小程序：wxEnterpriseId:{}", wxEnterpriseId);
        //发送小程序
        TabMiniprogramSetting miniprogramSetting = miniprogramSettingService.getMiniprogramSetting(wxEnterpriseId, enterpriseId);
        if (null == miniprogramSetting) {
            log.info("需要配置小程序配置：wxEnterpriseId:{},enterpriseId:{}", wxEnterpriseId, enterpriseId);
            return;
        }
        QywxMiniprogramExternalBaseDTO messageBaseDTO = new QywxMiniprogramExternalBaseDTO();
        messageBaseDTO.setAppid(miniprogramSetting.getAppId());
        messageBaseDTO.setPicMediaId(miniprogramSetting.getMediaId());
        messageBaseDTO.setTitle(miniprogramSetting.getTitle());
        messageBaseDTO.setPage(config.getMemberOpenPage() + relationKey);
        attachments.add(messageBaseDTO);
    }

    private void attachmentAddParamQrCode(List<QywxExternalMessageBaseDTO> attachments, String enterpriseId, String clerkId,
                                          WxEnterpriseDTO wxEnterpriseDTO, String relationKey) {
        if (StringUtils.isEmpty(enterpriseId) || StringUtils.isEmpty(clerkId)) {
            log.info("带参小程序无法发送");
            return;
        }
        //带参数的公众号二维码
        String sceneStr = "QWHY_" + relationKey + "_" + clerkId;
        //30天失效
        QRcodeDTO qRcodePic = imageService.getQRcodePic(enterpriseId, sceneStr, 2592000);
        log.info("参数的公众号二维码返回：{}", JSON.toJSONString(qRcodePic));
        if (qRcodePic != null) {
            String downloadUrl = qRcodePic.getPicUploadResDTO().downloadUrl;
            String[] arr = downloadUrl.split("/");
            JSONResponse jp = qywxSuiteApiService.uploadMedia(
                    wxEnterpriseDTO.getCorpid(),
                    config.getWxSuiteid(),
                    CommonUtil.getFileByte(downloadUrl),
                    arr[arr.length - 1],
                    QywxMediaTypeEnum.IMAGE.getCode());
            log.info("欢迎语发送带参数的公众号企微二维码返回：{}", JSON.toJSONString(jp));
            if (jp.getErrorCode() == 0) {
                QywxImageExternalBaseDTO qywxImageExternalBaseDTO = new QywxImageExternalBaseDTO();
                qywxImageExternalBaseDTO.setMediaId(jp.getResult().toString());
                attachments.add(qywxImageExternalBaseDTO);
            }
        }
    }


    /**
     * 组装数据
     *
     * @param dto
     * @return
     */
    public MemberUnionidRelatedDTO getMemberUnionidRelatedDTONew(MemberUnionidRelatedDTO dto) {
        log.info("【新增外部联系人回调】dto={}", JSON.toJSONString(dto));
        String corpId = dto.getCorpid();
        TabHaobanWxApplication tabHaobanWxApplication = wxApplicationMapper.selectByCorpId(corpId, null);
        if (tabHaobanWxApplication == null) {
            log.info("查询tab_haoban_wx_application为空：{}", corpId);
            return null;
        }
        String wxEnterpriseId = tabHaobanWxApplication.getWxEnterpriseId();
        //校验friend
        String userId = dto.getWxUserId();
        String suiteid = dto.getSuiteid();
        String externalUserid = dto.getExternalUserid();
        ExternalUserDTO externalUserDTO;
        if (SELF_APP.equals(suiteid)) {
            externalUserDTO = this.getCorpSelfExternalUseridInfo(wxEnterpriseId, userId, externalUserid);
        } else {
            externalUserDTO = this.getExternalUseridInfo(wxEnterpriseId, userId, externalUserid);
        }
        checkQywxSettingApiService.saveFriendCallback(wxEnterpriseId, externalUserDTO, dto);
        if (externalUserDTO == null) {
            log.info("【新增外部联系人回调】unionIdJson=null");
            return null;
        }
        dto.setWxEnterpriseId(wxEnterpriseId);
        dto.setExternalName(EmojiFilterUtil.removeAllEmoji(externalUserDTO.getName()));
        dto.setAddCreateTime(externalUserDTO.getAddCreateTime());
        dto.setAvatar(externalUserDTO.getAvatar());
        if (SELF_APP.equals(suiteid)) {
            dto.setUnionid(externalUserDTO.getUnionId());
            dto.setSelfExternalUserid(externalUserDTO.getExternalUserId());
            dto.setExternalUserid(null);
            dto.setAvatar(externalUserDTO.getAvatar());
        } else {
            dto.setExternalUserid(externalUserDTO.getExternalUserId());
        }

        String key = "external" + dto.getWxEnterpriseId() + "_" + dto.getExternalName() + "_" + dto.getAddCreateTime();
        String lockKey = key + "-lock";
        RedisUtil.lock(lockKey, 10L);

        MemberUnionidRelatedDTO midRelatedDto = RedisUtil.getCache(key, MemberUnionidRelatedDTO.class);
        if (midRelatedDto == null) {
            log.info("redis缓存中无该好友数据,插入数据：{}", JSON.toJSONString(dto));
            String memberUnionidRelatedId = memberUnionRelatedService.addMemberUnionidRelated(dto);
            dto.setMemberUnionidRelatedId(memberUnionidRelatedId);
            RedisUtil.setCache(key, dto, 180L);
            RedisUtil.unlock(lockKey);
            return null;
        }

        dto.setUnionid(StringUtils.isBlank(dto.getUnionid()) ? midRelatedDto.getUnionid() : dto.getUnionid());
        dto.setExternalUserid(StringUtils.isBlank(dto.getExternalUserid()) ? midRelatedDto.getExternalUserid() : externalUserid);
        dto.setSelfExternalUserid(StringUtils.isBlank(dto.getSelfExternalUserid()) ? midRelatedDto.getSelfExternalUserid() : dto.getSelfExternalUserid());
        dto.setAvatar(StringUtils.isBlank(dto.getAvatar()) ? midRelatedDto.getAvatar() : dto.getAvatar());
        dto.setMemberUnionidRelatedId(midRelatedDto.getMemberUnionidRelatedId());

        if (StringUtils.isAnyBlank(dto.getExternalUserid(), dto.getSelfExternalUserid())) {
            log.error("加好友异常、请检查配置是否正常(如：检查客户联系回调、老好办助手回调、代开发回调（是否配置多个回调、企微权限是否正常、密钥是否正确）、好办权限等)，wxEnterpriseId：{}", wxEnterpriseId);
            return null;
        }

        log.info("好办和好办助手均已回调：{}", JSON.toJSONString(dto));
        List<MemberUnionidRelatedDTO> relatedDTOS = memberUnionRelatedService.listBySelfExternalUserId(dto.getWxUserId(), dto.getWxEnterpriseId(), dto.getSelfExternalUserid());
        //老的关联需要删除
        if (CollectionUtils.isNotEmpty(relatedDTOS)) {
            relatedDTOS.stream().filter(mid -> (!mid.getMemberUnionidRelatedId().equals(midRelatedDto.getMemberUnionidRelatedId())))
                    .forEach(mid -> {
                        mid.setStatusFlag(0);
                        memberUnionRelatedService.update(mid);
                    });
        }
        memberUnionRelatedService.update(dto);
        RedisUtil.unlock(lockKey);
        RedisUtil.delCache(key);
        return dto;
    }


    private ExternalUserPojo getExternalUserPojo(String unionIdJson, String userId1, String wxEnterpriseId) {
        ExternalUserPojo pojo = new ExternalUserPojo();
        String unionId = "";
        String follow_user = "";
        String createTime = "";
        String userId = "";
        String avatar = "";
        String relaName = "";
        String externalUserId = "";
        if (StringUtils.isNotBlank(unionIdJson)) {
            JSONObject jo = JSON.parseObject(unionIdJson);
            String external_contact = jo.getString("external_contact");
            if (StringUtils.isNotBlank(external_contact)) {
                JSONObject jt = JSON.parseObject(external_contact);
                unionId = jt.getString("unionid");
                relaName = EmojiFilterUtil.filterEmojiLast(jt.getString("name"), true);
                if (StringUtils.isBlank(relaName)) {
                    relaName = "--";
                }
                avatar = jt.getString("avatar");
                externalUserId = jt.getString("external_userid");
            }

            follow_user = jo.getString("follow_user");
            if (StringUtils.isNotBlank(follow_user)) {
                JSONArray j = JSON.parseArray(follow_user);
                for (Object object : j) {
                    String followJson = JSON.toJSONString(object);
                    JSONObject follow = JSON.parseObject(followJson);
                    userId = follow.getString("userid");
                    if (userId.equals(userId1)) {
                        createTime = follow.getString("createtime");
                    }
                }
            }
        }
        pojo.setAddCreateTime(createTime);
        pojo.setAvatar(avatar);
        pojo.setName(relaName);
        pojo.setUnionId(unionId);
        pojo.setExternalUserId(externalUserId);
        pojo.setWxEnterpriseId(wxEnterpriseId);
        return pojo;
    }

    @Override
    public String add(String wxEnterpriseId, String selfExternalUserId, String userId, String storeId) {
        WxEnterpriseDTO wxEnterprise = wxEnterpriseService.selectById(wxEnterpriseId);
        if (wxEnterprise == null) {
            return "";
        }

        TabHaobanStaff staff = staffService.selectByUserIdAndEnterpriseId(userId, wxEnterpriseId);
        if (staff == null) {
            return "";
        }

        SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(wxEnterpriseId, SecretTypeEnum.CONTACT_CUSTOMER.getVal());
        if (null == secretSetting) {
            log.info("没有配置secret");
            return "";
        }
        String unionIdJson = qywxUserApiService.getCorpSelfExternalUseridInfo(wxEnterprise.getCorpid(), secretSetting.getSecretVal(), selfExternalUserId);

        ExternalUserPojo pojo = getExternalUserPojo(unionIdJson, userId, wxEnterpriseId);
        String unionId = pojo.getUnionId();
        String name = pojo.getName();
        String createTime = pojo.getAddCreateTime();


        MemberUnionidRelatedDTO dto = new MemberUnionidRelatedDTO();
        String externalUserId = getExternalUserId(wxEnterprise, userId, createTime, name);
        if (StringUtils.isBlank(externalUserId)) {
            log.error("请求外部联系人id失败,userId:{}", userId);
            return "";
        }
        dto.setExternalUserid(externalUserId);
        dto.setWxEnterpriseId(wxEnterpriseId);
        dto.setUnionid(unionId);

        dto.setExternalName(name);
        dto.setAddCreateTime(createTime);
        dto.setWxUserId(userId);
        dto.setAvatar(pojo.getAvatar());
        if (StringUtils.isBlank(unionId)) {
            return "";
        }
        dto.setSuiteid(secretSetting.getSecretVal());
        MemberUnionidRelatedDTO exsitDTO = memberUnionRelatedService.getByParams(userId, wxEnterpriseId, name, createTime);
        String uuid = "";
        if (exsitDTO == null) {
            dto.setUnionid(unionId);
            //更新对外联系人id
            dto.setSelfExternalUserid(selfExternalUserId);
            uuid = memberUnionRelatedService.addMemberUnionidRelated(dto);
        } else {
            exsitDTO.setExternalUserid(externalUserId);
            exsitDTO.setUnionid(unionId);
            //更新对外联系人id
            exsitDTO.setSelfExternalUserid(selfExternalUserId);
            memberUnionRelatedService.update(exsitDTO);
            uuid = exsitDTO.getMemberUnionidRelatedId();
        }

        //新增门店和导购的关联关系
        insertExternalClerkRelated(dto);
        return uuid;
    }

    @Deprecated
    private void insertExternalClerkRelated(MemberUnionidRelatedDTO dto) {
        log.info("新增外部联系人开始：{}", JSONObject.toJSONString(dto));
        String wxUserId = dto.getWxUserId();
        String wxEnterpriseId = dto.getWxEnterpriseId();
        String name = dto.getExternalName();
        String createTime = dto.getAddCreateTime();
        String externalUserId = dto.getExternalUserid();
        String avatar = dto.getAvatar();
        String unionId = dto.getUnionid();
        if (StringUtils.isAnyBlank(wxUserId, wxEnterpriseId, name, createTime, unionId)) {
            log.info("【新增外部联系人】wxUserId={},wxEnterpriseId={},name={},createTime={},avatar={},unionId={}", wxUserId, wxEnterpriseId, name, createTime, avatar, unionId);
            return;
        }
        TabHaobanStaff staff = staffService.selectByUserIdAndEnterpriseId(wxUserId, wxEnterpriseId);
        if (staff == null) {
            return;
        }
        String staffId = staff.getStaffId();

        MemberDTO member = null;
        TabHaobanClerkMainStoreRelated mainStoreByStaffId = clerkMainStoreRelatedService.getMainStoreByStaffId(staffId, wxEnterpriseId);
        if (mainStoreByStaffId == null) {
            log.info("【新增外部联系人】主门店为空");
            return;
        }
        String storeId = mainStoreByStaffId.getStoreId();
        StaffClerkRelationDTO staffClerkRelationDTO = staffClerkRelationService.getOneBindByStoreId(staffId, storeId);
        if (staffClerkRelationDTO == null) {
            log.info("【新增外部联系人】导购和clerk关联为空");
            return;
        }
        //新增导购和外部联系人关系
        String clerkCode = staffClerkRelationDTO.getClerkCode();
        ClerkDTO clerk = clerkService.getClerkByClerkCode(staffClerkRelationDTO.getEnterpriseId(), clerkCode);
        log.info("【新增外部联系人】clerkCode={},unionid:{}", clerkCode, unionId);
        if (clerk == null) {
            log.info("【新增外部联系人】导购为空");
            return;
        }
        String qrcodeParam = clerk.getQrcodeParam();
        if (StringUtils.isBlank(qrcodeParam)) {
            powerService.saveClerkQrCode(clerk.getClerkId());
            clerk = clerkService.getClerkByClerkCode(staffClerkRelationDTO.getEnterpriseId(), clerkCode);
            qrcodeParam = clerk.getQrcodeParam();
        }
        if (StringUtils.isNotBlank(qrcodeParam) && StringUtils.isNotBlank(unionId)) {
            log.info("【新增外部联系人会员】enterpriseId={},unionId={},name={},avatar={},QrcodeParam={}", staffClerkRelationDTO.getEnterpriseId(), unionId, name, avatar, qrcodeParam);
            member = memberOpenCardBusinessService.getMemberByQywxChannelParam(staffClerkRelationDTO.getEnterpriseId(), unionId, "", name, avatar, qrcodeParam);
        }

        TabHaobanExternalClerkRelated exsitDTO = externalClerkRelatedService.getByParams(wxUserId, wxEnterpriseId, name, createTime);
        String key = wxUserId + wxEnterpriseId + name + createTime;
        if (exsitDTO == null) {
            RedisUtil.lock(key, 1L);
            exsitDTO = externalClerkRelatedService.getByParams(wxUserId, wxEnterpriseId, name, createTime);
            RedisUtil.unlock(key);
        }
        if (exsitDTO == null) {
            TabHaobanExternalClerkRelated related = new TabHaobanExternalClerkRelated();
            related.setAddCreateTime(createTime);
            related.setClerkId(staffClerkRelationDTO.getClerkId());
            related.setEnterpriseId(staffClerkRelationDTO.getEnterpriseId());
            related.setExternalName(name);
            related.setExternalUserId(externalUserId);
            related.setStaffId(staffId);
            related.setMemberUnionidRelatedId(dto.getMemberUnionidRelatedId());
            related.setStoreId(storeId);
            related.setUnionid(unionId);
            related.setWxEnterpriseId(wxEnterpriseId);
            related.setWxUserId(wxUserId);
            if (member != null) {
                related.setMemberId(member.getMemberId());
            }
            externalClerkRelatedService.insert(related);

        } else {
            if (member != null) {
                exsitDTO.setMemberId(member.getMemberId());
            }
            exsitDTO.setMemberUnionidRelatedId(dto.getMemberUnionidRelatedId());
            exsitDTO.setExternalUserId(externalUserId);
            exsitDTO.setUnionid(unionId);
            exsitDTO.setStoreId(storeId);
            exsitDTO.setEnterpriseId(staffClerkRelationDTO.getEnterpriseId());
            exsitDTO.setClerkId(staffClerkRelationDTO.getClerkId());
            externalClerkRelatedService.update(exsitDTO);
        }
    }

    /**
     * 查询外部联系人id
     *
     * @param wxEnterprise
     * @param userId
     * @param createTime
     * @param name
     * @return
     */
    private String getExternalUserId(WxEnterpriseDTO wxEnterprise, String userId, String createTime, String name) {
        log.info("新增外部联系人】corpid={},suiteId={},userId1={}", wxEnterprise.getCorpid(), config.getWxSuiteid(), userId);
        String wxRes = qywxUserApiService.listExternalUserid(wxEnterprise.getCorpid(), config.getWxSuiteid(), userId);
        String externalUserId = "";
        log.info("【新增外部联系人】wxRes={}", wxRes);
        if (StringUtils.isBlank(wxRes)) {
            log.error("请求企微 listExternalUserid 失败：userId:{}", userId);
            return "";
        }
        JSONArray jsonArr = JSON.parseArray(wxRes);
        String wxName = "";
        for (Object externalUserid : jsonArr) {
            String uJ = qywxUserApiService.getExternalUseridInfo(wxEnterprise.getCorpid(), config.getWxSuiteid(), externalUserid.toString());
            log.info("【新增外部联系人】uJ={}", uJ);
            if (StringUtils.isNotBlank(uJ)) {
                JSONObject jo = JSON.parseObject(uJ);
                String external_contact = jo.getString("external_contact");
                String uj_follow_user = jo.getString("follow_user");
                JSONObject jt = null;
                if (StringUtils.isNotBlank(external_contact)) {
                    jt = JSON.parseObject(external_contact);
                    wxName = EmojiFilterUtil.filterEmojiLast(jt.getString("name"), true);
                    if (StringUtils.isBlank(wxName)) {
                        wxName = "--";
                    }
                }
                if (StringUtils.isNotBlank(uj_follow_user)) {
                    JSONArray j = JSON.parseArray(uj_follow_user);
                    String uj_userId = "";
                    for (Object object : j) {
                        String followJson = JSON.toJSONString(object);
                        JSONObject follow = JSON.parseObject(followJson);
                        uj_userId = follow.getString("userid");
                        log.info("【新增外部联系人】createTime={},name={},followCreateTime={},wxName={}", createTime, name, follow.getString("createtime"), wxName);
                        if (uj_userId.equals(userId) && createTime.equals(follow.getString("createtime")) && name.equals(wxName)) {
                            if (jt != null) {
                                externalUserId = jt.getString("external_userid");
                                break;
                            }
                        }
                    }
                }
            }
            if (StringUtils.isNotBlank(externalUserId)) {
                break;
            }
        }
        return externalUserId;
    }

    @Override
    public void delMemberUnionidRelated(MemberUnionidRelatedDTO dto) {
        DealQywxExternalUserPojo dealQywxExternalUserPojo = new DealQywxExternalUserPojo();
        dealQywxExternalUserPojo.setType(DealQywxExternalUserPojo.DealType.del.getType());
        dealQywxExternalUserPojo.setData(dto);

        GicMQClient instance = GICMQClientUtil.getClientInstance();
        try {
            instance.sendMessage("dealQywxExternalUserMq", JSONObject.toJSONString(dealQywxExternalUserPojo));
        } catch (Exception e) {
            log.info("异步处理异常：{}", e);
        }
    }

    @Override
    public void editMemberUnionidRelated(MemberUnionidRelatedDTO dto) {
        DealQywxExternalUserPojo dealQywxExternalUserPojo = new DealQywxExternalUserPojo();
        dealQywxExternalUserPojo.setType(DealQywxExternalUserPojo.DealType.edit.getType());
        dealQywxExternalUserPojo.setData(dto);

        GicMQClient instance = GICMQClientUtil.getClientInstance();
        try {
            instance.sendMessage("dealQywxExternalUserMq", JSONObject.toJSONString(dealQywxExternalUserPojo));
        } catch (Exception e) {
            log.info("异步处理异常：{}", e);
        }
    }

    /**
     * 删除好友
     *
     * @param dto
     */
    private void delMemberUnionidRelatedProcess(MemberUnionidRelatedDTO dto) {
        externalClerkRelatedService.delByUserIdAndExternalUserId(dto);
        memberUnionRelatedService.delMemberUnionidRelated(dto);
    }

    private void editMemberUnionidRelatedProcess(MemberUnionidRelatedDTO dto) {
        log.info("修改标签/会员信息回调：{}", JSONObject.toJSONString(dto));
        TabHaobanWxEnterprise wxEnterprise = wxEnterpriseService.getEnterpriseBycorpId(dto.getCorpid());
        if (null == wxEnterprise) {
            return;
        }
        if (dto.getSuiteid().equals(SELF_APP)) {
            log.info("self不执行");
            return;
        }

        pushTagSync(dto.getExternalUserid(), dto.getWxUserId()
                , GicQywxSyncTypeEnum.FRIEND_TAG_SYNC.getType(), QywxSyncTaskTypeEnum.MEMBER_SYNC.getType(), wxEnterprise.getWxEnterpriseId(), null);
    }

    @Override
    public ExternalClerkRelatedDTO getByMemberId(String staffId, String memberId) {
        TabHaobanStaff staff = staffService.selectById(staffId);
        if (staff == null) {
            return null;
        }
        log.info("【查询会员】wxUserId={},memberId={}", staff.getWxUserId(), memberId);
        return externalClerkRelatedService.getByMemberId(staff.getWxUserId(), memberId);
    }

    @Override
    public List<MemberUnionidRelatedDTO> getByWxUserIdAndWxEnterpriseId(String wxUserId, String wxEnterpriseId) {
        List<MemberUnionidRelatedDTO> list = memberUnionRelatedService.getByWxUserIdAndWxEnterpriseId(wxUserId, wxEnterpriseId);
        return list;
    }

    @Override
    public List<MemberUnionidRelatedDTO> listByEnterpriseIdAndDate(String enterpriseId, Date date) {
        List<MemberUnionidRelated> list = memberUnionidRelatedMapper.listByEnterpriseIdAndDate(enterpriseId, date);
        return EntityUtil.changeEntityListByJSON(MemberUnionidRelatedDTO.class, list);
    }

    @Override
    public void freshWxFrend(String wxEnterpriseId, String wxUserId, String storeId) {
        log.info("【刷下好友】wxUserId={}", wxUserId);
        WxEnterpriseDTO enterprise = wxEnterpriseService.selectById(wxEnterpriseId);

        String wxRes = qywxUserApiService.listExternalUserid(enterprise.getCorpid(), config.getWxSuiteid(), wxUserId);
        List<MemberUnionidRelatedDTO> list = this.getByWxUserIdAndWxEnterpriseId(wxUserId, wxEnterpriseId);
        List<String> externalUserIdList = list.stream().map(external -> external.getExternalUserid())
                .collect(Collectors.toList());
        JSONArray externalArr = JSON.parseArray(wxRes);
        for (String externalUserId : externalUserIdList) {
            if (!externalArr.contains(externalUserId)) {
                //删除成员和外部联系人关系
                MemberUnionidRelatedDTO dto = new MemberUnionidRelatedDTO();
                dto.setExternalUserid(externalUserId);
                dto.setWxUserId(wxUserId);
                memberUnionRelatedService.delMemberUnionidRelated(dto);
                //删除导购和外部联系人关系
                externalClerkRelatedService.delByUserIdAndExternalUserId(dto);
            }
        }


        SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(wxEnterpriseId, SecretTypeEnum.CONTACT_CUSTOMER.getVal());
        if (null == secretSetting || secretSetting.getCheckFlag() == 0) {
            log.info("没有配置客户联系secret:{}", wxEnterpriseId);
            return;
        }
        String res = qywxUserApiService.listSelfExternalUserid(enterprise.getCorpid(), secretSetting.getSecretVal(), wxUserId);
        log.info("【刷下好友】res={}", res);
        if (StringUtils.isBlank(res)) {
            return;
        }
        JSONArray jsonArr = JSON.parseArray(res);
        if (jsonArr.size() == 0) {
            return;
        }

        for (Object object : jsonArr) {
            this.add(wxEnterpriseId, object.toString(), wxUserId, storeId);
        }
    }

    @Override
    public void mqFreshWxFrend(String res) {
        JSONObject json = JSON.parseObject(res);
        String wxEnterpriseId = json.getString("wxEnterpriseId");
        String wxUserId = json.getString("wxUserId");
        String storeId = json.getString("storeId");
        log.info("【刷下微信好友】wxEnterpriseId={}.wxUserId={},storeId={}", wxEnterpriseId, wxUserId, storeId);
        if (StringUtils.isAnyBlank(wxEnterpriseId, wxUserId, storeId)) {
            return;
        }
        freshWxFrend(wxEnterpriseId, wxUserId, storeId);
    }

    @Override
    public void cleanByCid(String cid) {
        if (StringUtils.isNotBlank(cid)) {
            TabHaobanWxEnterprise wxEnterprise = wxEnterpriseService.getEnterpriseBycorpId(cid);
            if (null != wxEnterprise) {
                memberUnionRelatedService.clean(wxEnterprise.getWxEnterpriseId());
            }
        } else {
            memberUnionRelatedService.clean(null);
        }
    }

    @Override
    public Page<MemberUnionidRelatedDTO> pageMemberUnionByParams(List<String> userIdList, List<String> sendMemberIds,
                                                                 String enterpriseId, BasePageInfo pageInfo) {
        PageHelper.startPage(pageInfo.getPageNum(), pageInfo.getPageSize());
        return PageUtil.changePageHelperToCurrentPage(memberUnionRelatedService.pageMemberUnionByParams(userIdList, sendMemberIds, enterpriseId), MemberUnionidRelatedDTO.class);
    }

    /**
     * 老的单个素材群发的api
     *
     * @param wxEnterpriseId : 微信企业id
     * @param userId         : 用户id
     * @param extendUserList : 发送的用户id
     * @param materialId     : 素材id
     * @return : 返回群发执行结果
     */
    @Override
    public String sendMessage(String wxEnterpriseId, String userId, List<String> extendUserList, String materialId) {
        JSONResponse jp = this.sendMessage(wxEnterpriseId, userId, extendUserList, Collections.singletonList(materialId));
        //返回执行结果, msgId
        log.info("【发送消息】jp = {}", JSON.toJSONString(jp));
        Map<String, Object> returnMap = jp.getReturnMap();
        return returnMap.get("msgid") == null ? "" : returnMap.get("msgid").toString();
    }

    /**
     * 创建企业群发, 支出素材批量发送
     *
     * @param wxEnterpriseId : 微信企业id
     * @param userId         : 用户id
     * @param extendUserList : 发送的用户id
     * @param materialIdList : 素材id列表
     * @return : 返回群发执行结果
     */
    @Override
    public JSONResponse sendMessage(String wxEnterpriseId, String userId, List<String> extendUserList, List<String> materialIdList) {
        //群发请求参数
        QywxExternalMessageDTO qywxExternalMessageDTO = new QywxExternalMessageDTO();
        //素材列表
        List<QywxMessageMaterialDTO> messageMaterialList = new ArrayList<>();
        materialIdList.forEach(materialId -> {
            MaterialDTO material = materialApiService.getHasChangeMadieMaterialById(materialId);
            if (material == null) {
                return;
            }
            if (material.getMaterialType() == 1) {
                qywxExternalMessageDTO.setContent(material.getMaterialContent());
            } else {
                messageMaterialList.add(this.getMessageMaterial(material));
            }
        });
        //素材列表不存在, 并且不存在文本内容, 不执行
        if (messageMaterialList.isEmpty() && StringUtils.isBlank(qywxExternalMessageDTO.getContent())) {
            JSONResponse jp = new JSONResponse();
            jp.setErrorCode(-1);
            jp.setErrorMessage("群发素材不存在, 群发创建失败");
            return jp;
        }
        WxEnterpriseDTO enterprise = wxEnterpriseService.selectById(wxEnterpriseId);
        //请求参数赋值
        qywxExternalMessageDTO.setChatType("single");
        qywxExternalMessageDTO.setExternalUserid(extendUserList);
        String corpid = enterprise.getCorpid();
        if (corpid.length() > 20) {
            TabHaobanStaff tabHaobanStaff = staffService.selectByUserIdAndEnterpriseId(userId, wxEnterpriseId);
            if (tabHaobanStaff == null) {
                JSONResponse jp = new JSONResponse();
                jp.setErrorCode(-1);
                jp.setErrorMessage("员工未查询到，群发创建失败,userId:" + userId);
                return jp;
            }
            qywxExternalMessageDTO.setSenderUserId(tabHaobanStaff.getWxOpenUseId());
        } else {
            qywxExternalMessageDTO.setSenderUserId(userId);
        }
        qywxExternalMessageDTO.setAttachments(messageMaterialList);
        //调接口执行创建群发
        return qywxSuiteApiService.sendExternalMessage(corpid, config.getWxSuiteid(), qywxExternalMessageDTO);
    }

    /**
     * 素材发送对象构造
     *
     * @param material : 素材对象
     * @return : 返回素材发送对象
     */
    private QywxMessageMaterialDTO getMessageMaterial(MaterialDTO material) {
        //素材类型
        Integer materialType = material.getMaterialType();
        //主键id
        String materialId = material.getMaterialId();
        //企微对应的id
        String maerialId = material.getMediaId();
        //判断素材企微id是否需要刷新
        List<Integer> materialTypeList = Arrays.asList(2, 4, 6);
        if (materialTypeList.contains(materialType)) {
            Date wxLastTime = material.getWxLastUploadTime();
            if (DateUtil.addDay(wxLastTime, 3).getTime() < System.currentTimeMillis()) {
                maerialId = materialApiService.reUpdalodMetail(materialId);
            }
        }
        //素材对象
        QywxMessageMaterialDTO dto = new QywxMessageMaterialDTO();
        if (materialType == 2) {
            QywxImageMaterialDTO imageMaterialDTO = new QywxImageMaterialDTO();
            imageMaterialDTO.setMediaId(maerialId);
            dto.setMsgType(QywxMediaTypeEnum.IMAGE.getName());
            dto.setImage(imageMaterialDTO);
        } else if (materialType == 3) {
            QywxLinkMaterialDTO linkMaterialDTO = new QywxLinkMaterialDTO();
            linkMaterialDTO.setTitle(material.getMaterialTitle());
            linkMaterialDTO.setPicUrl(material.getWxImgUrl());
            linkMaterialDTO.setDesc(material.getMaterialDesc());
            linkMaterialDTO.setUrl(material.getLink());
            dto.setMsgType(QywxMediaTypeEnum.LINK.getName());
            dto.setLink(linkMaterialDTO);
        } else if (materialType == 4) {
            QywxVideoMaterialDTO videoMaterialDTO = new QywxVideoMaterialDTO();
            videoMaterialDTO.setMediaId(maerialId);
            dto.setMsgType(QywxMediaTypeEnum.VIDEO.getName());
            dto.setVideo(videoMaterialDTO);
        } else if (materialType == 6) {
            QywxMiniprogramMaterialDTO miniprogramMaterialDTO = new QywxMiniprogramMaterialDTO();
            miniprogramMaterialDTO.setTitle(material.getMaterialTitle());
            miniprogramMaterialDTO.setPicMediaId(maerialId);
            miniprogramMaterialDTO.setAppid(material.getAppId());
            miniprogramMaterialDTO.setPage(material.getLink());
            dto.setMsgType(QywxMediaTypeEnum.MINIPROGRAM.getName());
            dto.setMiniprogram(miniprogramMaterialDTO);
        }
        return dto;
    }

    /**
     * 获取群发成员发送任务列表
     *
     * @param wxEnterpriseId : 微信企业id
     * @param wxMessageId    : 消息id
     * @param cursor         : 分页游标
     * @return : 返回请求结果
     */
    @Override
    public JSONResponse taskExternalMessage(String wxEnterpriseId, String wxMessageId, String cursor) {
        WxEnterpriseDTO enterprise = wxEnterpriseService.selectById(wxEnterpriseId);
        if (enterprise == null) {
            return null;
        }
        return qywxSuiteApiService.taskExternalMessage(enterprise.getCorpid(), config.getWxSuiteid(), wxMessageId, cursor);
    }

    /**
     * 获取企业群发成员执行结果
     *
     * @param wxEnterpriseId : 微信企业id
     * @param wxMessageId    : 消息id
     * @param cursor         : 分页游标
     * @param userId         : 用户id
     * @return : 返回请求结果
     */
    @Override
    public JSONResponse resultExternalMessage(String wxEnterpriseId, String wxMessageId, String cursor, String userId) {
        WxEnterpriseDTO enterprise = wxEnterpriseService.selectById(wxEnterpriseId);
        if (enterprise == null) {
            return null;
        }
        return qywxSuiteApiService.resultExternalMessage(enterprise.getCorpid(), config.getWxSuiteid(), wxMessageId, cursor, userId);
    }

    @Override
    public JSONResponse getMessageStatus(String wxEnterpriseId, String wxMessageId) {
        WxEnterpriseDTO enterprise = wxEnterpriseService.selectById(wxEnterpriseId);
        if (enterprise == null) {
            return null;
        }
        return qywxSuiteApiService.resultExternalMessage(enterprise.getCorpid(), config.getWxSuiteid(), wxMessageId);
    }

    @Override
    public List<MemberUnionidRelatedDTO> getByWxUserIdListAndWxEnterpriseId(List<String> userIdList, String wxEnterpriseId) {
        return EntityUtil.changeEntityListByJSON(MemberUnionidRelatedDTO.class, memberUnionidRelatedMapper.getByWxUserIdListAndWxEnterpriseId(userIdList, wxEnterpriseId));
    }

    @Override
    public void cleanNoExsitFriend(String wxEnterpriseId, String wxUserId, String wxRes) {
        log.info("【清除不存在的好友】wxEnterpriseId={},wxUserId={}", wxEnterpriseId, wxUserId);
        List<MemberUnionidRelatedDTO> list = this.getByWxUserIdAndWxEnterpriseId(wxUserId, wxEnterpriseId);
        List<String> externalUserIdList = list.stream().map(external -> external.getExternalUserid())
                .collect(Collectors.toList());
        if (StringUtils.isBlank(wxRes)) {
            log.info("【清除不存在的好友不存在】wxEnterpriseId={},wxUserId={}", wxEnterpriseId, wxUserId);
            return;
        }
        JSONArray externalArr = JSON.parseArray(wxRes);
        for (String externalUserId : externalUserIdList) {
            if (!externalArr.contains(externalUserId)) {
                //删除成员和外部联系人关系
                MemberUnionidRelatedDTO dto = new MemberUnionidRelatedDTO();
                dto.setExternalUserid(externalUserId);
                dto.setWxUserId(wxUserId);
                memberUnionRelatedService.delMemberUnionidRelated(dto);
                //删除导购和外部联系人关系
                externalClerkRelatedService.delByUserIdAndExternalUserId(dto);
            }
        }
    }

    @Override
    public List<String> listSelfExterialList(String wxEnterpriseId, String wxUserId) {
        try {
            log.info("【查询自建应用好友】wxEnterpriseId={},wxUserId={}", wxEnterpriseId, wxUserId);
            WxEnterpriseDTO enterprise = wxEnterpriseService.selectById(wxEnterpriseId);
            List<String> list = new ArrayList<>();
            SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(wxEnterpriseId, SecretTypeEnum.CONTACT_CUSTOMER.getVal());
            if (null == secretSetting || secretSetting.getCheckFlag() == 0) {
                log.info("没有配置客户联系secret:{}", wxEnterpriseId);
                return list;
            }
            String res = qywxUserApiService.listSelfExternalUserid(enterprise.getCorpid(), secretSetting.getSecretVal(), wxUserId);
            log.info("【查询自建应用】res={}", res);
            if (res != null && res.equals("1")) {
                log.info("代表需要重试");
                return null;
            }
            if (StringUtils.isBlank(res)) {
                return list;
            }
            JSONArray jsonArr = JSON.parseArray(res);
            if (jsonArr.size() == 0) {
                return list;
            }
            for (Object object : jsonArr) {
                list.add(object.toString());
            }
            return list;
        } catch (Exception e) {
            log.info("错误={}", e);
        }
        return null;
    }

    @Override
    public List<String> listExterialList(String wxEnterpriseId, String wxUserId) {
        log.info("【获取第三方应用好友】wxEnterpriseId={},wxUserId={}", wxEnterpriseId, wxUserId);
        WxEnterpriseDTO enterprise = wxEnterpriseService.selectById(wxEnterpriseId);
        String corpid = enterprise.getCorpid();
        String userId = "";
        TabHaobanStaff staff = staffService.selectByUserIdAndEnterpriseId(wxUserId, wxEnterpriseId);
        if (staff == null) {
            log.error("员工为空，wxUserId：{}", wxUserId);
            return null;
        }
        if (corpid.length() > 20) {
            userId = staff.getWxOpenUseId();
        } else {
            userId = staff.getWxUserId();
        }
        log.info("【获取第三方应用好友】wxEnterpriseId={},userId={}", wxEnterpriseId, userId);
        String wxRes = qywxUserApiService.listExternalUserid(corpid, config.getWxSuiteid(), userId);
        List<String> list = new ArrayList<>();
        log.info("【查询第三方应用】res={}", wxRes);
        if ("1".equals(wxRes)) {
            log.info("代表需要重试");
            return null;
        }
        if (StringUtils.isBlank(wxRes)) {
            return list;
        }
        JSONArray jsonArr = JSON.parseArray(wxRes);
        if (jsonArr.size() == 0) {
            return list;
        }
        for (Object object : jsonArr) {
            list.add(object.toString());
        }
        return list;
    }

    @Override
    public ExternalUserDTO getCorpSelfExternalUseridInfo(String wxEnterpriseId, String wxUserId, String externalUserId) {
        WxEnterpriseDTO wxEnterprise = wxEnterpriseService.selectById(wxEnterpriseId);
        if (wxEnterprise == null) {
            log.info("企业不存在");
            return null;
        }
        SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(wxEnterpriseId, SecretTypeEnum.HAOBAN_HELP.getVal());
        if (null == secretSetting) {
            log.info("没有配置secret");
            return null;
        }
        String unionIdJson = qywxUserApiService.getCorpSelfExternalUseridInfo(wxEnterprise.getCorpid(), secretSetting.getSecretVal(), externalUserId);
        if (StringUtils.isBlank(unionIdJson)) {
            log.info("好友不存在");
            return null;
        } else if ("1".equals(unionIdJson)) {
            log.info("接口调用被限制");
            throw new WxApiLimitException("getCorpSelfExternalUseridInfo接口调用被限制");
        }
        ExternalUserPojo pojo = getExternalUserPojo(unionIdJson, wxUserId, wxEnterpriseId);
        return EntityUtil.changeEntityByJSON(ExternalUserDTO.class, pojo);
    }

    @Override
    public ExternalUserDTO getExternalUseridInfo(String wxEnterpriseId, String wxUserId, String externalUserId) {
        log.info("查询第三方:wxEnterpriseId:{},wxUserId:{},externalUserId:{}", wxEnterpriseId, wxUserId, externalUserId);
        WxEnterpriseDTO wxEnterprise = wxEnterpriseService.selectById(wxEnterpriseId);
        if (wxEnterprise == null) {
            log.info("企业不存在");
            return null;
        }
        TabHaobanStaff tabHaobanStaff = staffService.selectByUserIdAndEnterpriseId(wxUserId, wxEnterpriseId);
        if (tabHaobanStaff == null) {
            log.info("员工不存在，wxUserId：{}", wxUserId);
            return null;
        }
        String wxOpenUseId = tabHaobanStaff.getWxOpenUseId();
        String uJ = qywxUserApiService.getExternalUseridInfo(wxEnterprise.getCorpid(), config.getWxSuiteid(), externalUserId);
        if (StringUtils.isBlank(uJ)) {
            log.info("好友不存在");
            return null;
        } else if ("1".equals(uJ)) {
            log.info("限制次数");
            throw new WxApiLimitException("getExternalUseridInfo接口次数限制");
        }
        String name = "";
        String createTime = "";
        String avatar = "";
        Integer friendType = 1;
        if (StringUtils.isNotBlank(uJ)) {
            JSONObject jo = JSON.parseObject(uJ);
            String external_contact = jo.getString("external_contact");
            String uj_follow_user = jo.getString("follow_user");
            JSONObject jt = null;
            if (StringUtils.isNotBlank(external_contact)) {
                jt = JSON.parseObject(external_contact);
                name = EmojiFilterUtil.filterEmojiLast(jt.getString("name"), true);
                if (StringUtils.isBlank(name)) {
                    name = "--";
                }
                friendType = jt.getInteger("type");
                avatar = jt.getString("avatar");
            }
            if (StringUtils.isNotBlank(uj_follow_user)) {
                JSONArray j = JSON.parseArray(uj_follow_user);
                String uj_userId = "";
                for (Object object : j) {
                    String followJson = JSON.toJSONString(object);
                    JSONObject follow = JSON.parseObject(followJson);
                    uj_userId = follow.getString("userid");
                    //第三方返回的是加密的，多做一层判断
                    if (uj_userId.equals(wxUserId) || uj_userId.equals(wxOpenUseId)) {
                        if (jt != null) {
                            externalUserId = jt.getString("external_userid");
                            createTime = follow.getString("createtime");
                            break;
                        }
                    }
                }
            }
        }
        ExternalUserPojo pojo = new ExternalUserPojo();
        pojo.setExternalUserId(externalUserId);
        pojo.setName(name);
        pojo.setAddCreateTime(createTime);
        pojo.setWxEnterpriseId(wxEnterpriseId);
        pojo.setAvatar(avatar);
        pojo.setFriendType(friendType);
        return EntityUtil.changeEntityByJSON(ExternalUserDTO.class, pojo);
    }

    @Override
    public String addExternal(ExternalUserDTO dto) {
        String wxUserId = dto.getWxUserId();
        String wxEnterpriseId = dto.getWxEnterpriseId();
        String name = StringUtils.isBlank(dto.getName()) ? "--" : dto.getName();
        String createTime = dto.getAddCreateTime();
        String unionId = dto.getUnionId();
        String externalUserId = dto.getExternalUserId();
        String memberId = dto.getMemberId();
        String storeId = dto.getStoreId();
        String enterpriseId = dto.getEnterpriseId();
        String staffId = dto.getStaffId();
        String avatar = dto.getAvatar();
        String clerkId = dto.getClerkId();
        if (StringUtils.isAnyBlank(wxUserId, wxEnterpriseId, name, createTime, unionId, externalUserId, memberId, storeId, enterpriseId, staffId, clerkId)) {
            log.info("【新增外部联系人】wxUserId={},wxEnterpriseId={},name={},createTime={},unionId ={},externalUserId ={},memberId ={},storeId ={},enterpriseId ={},staffId={},clerkId={}"
                    + "", wxUserId, wxEnterpriseId, name, createTime, unionId, externalUserId, memberId, storeId, enterpriseId, staffId, clerkId);
            return "参数不对";
        }
        MemberUnionidRelatedDTO exsitDTO = memberUnionRelatedService.getByWxUserIdAndUnionId(wxEnterpriseId, wxUserId, unionId);
        String uuid = "";
        if (exsitDTO == null) {
            exsitDTO = new MemberUnionidRelatedDTO();
            exsitDTO.setAvatar(avatar);
            exsitDTO.setExternalUserid(externalUserId);
            exsitDTO.setAddCreateTime(createTime);
            exsitDTO.setEnterpriseId(enterpriseId);
            exsitDTO.setExternalName(name);
            exsitDTO.setSelfExternalUserid(dto.getSelfExternalUserId());
            exsitDTO.setWxEnterpriseId(wxEnterpriseId);
            exsitDTO.setWxUserId(wxUserId);
            exsitDTO.setUnionid(unionId);
            exsitDTO.setMemberId(memberId);
            exsitDTO.setEnterpriseId(enterpriseId);
            uuid = memberUnionRelatedService.addMemberUnionidRelated(exsitDTO);
        } else {
            uuid = exsitDTO.getMemberUnionidRelatedId();
            exsitDTO.setAvatar(avatar);
            exsitDTO.setExternalUserid(externalUserId);
            exsitDTO.setUnionid(unionId);
            exsitDTO.setAddCreateTime(createTime);
            exsitDTO.setExternalName(name);
            exsitDTO.setSelfExternalUserid(dto.getSelfExternalUserId());
            exsitDTO.setMemberId(memberId);
            exsitDTO.setEnterpriseId(enterpriseId);
            memberUnionRelatedService.update(exsitDTO);
        }
        String relationKey = SecureUtil.md5(staffId + externalUserId);
        List<TabHaobanExternalClerkRelated> clerkRelateds = externalClerkRelatedService.listByExTernalUseridAndWxUserIdAllStatus(wxEnterpriseId, externalUserId, wxUserId);
        if (CollectionUtils.isEmpty(clerkRelateds)) {
            TabHaobanExternalClerkRelated related = new TabHaobanExternalClerkRelated();
            related.setAddCreateTime(createTime);
            related.setClerkId(clerkId);
            related.setEnterpriseId(enterpriseId);
            related.setExternalName(name);
            related.setExternalUserId(externalUserId);
            related.setStaffId(staffId);
            related.setMemberUnionidRelatedId(uuid);
            related.setStoreId(storeId);
            related.setRelationKey(relationKey);
            related.setUnionid(unionId);
            related.setWxEnterpriseId(wxEnterpriseId);
            related.setWxUserId(wxUserId);
            related.setMemberId(memberId);
            related.setHeadUrl(dto.getAvatar());
            related.setStatusFlag(1);
            externalClerkRelatedService.insert(related);
        } else {
            TabHaobanExternalClerkRelated external = clerkRelateds.get(0);
            external.setMemberId(memberId);
            external.setMemberUnionidRelatedId(uuid);
            external.setExternalUserId(externalUserId);
            external.setExternalName(name);
            external.setRelationKey(relationKey);
            external.setUnionid(unionId);
            external.setStoreId(storeId);
            external.setEnterpriseId(enterpriseId);
            external.setClerkId(clerkId);
            external.setStaffId(staffId);
            external.setMemberId(memberId);
            external.setHeadUrl(dto.getAvatar());
            external.setStatusFlag(1);
            externalClerkRelatedService.update(external);
        }
        //同步标签
        pushTagSync(memberId, wxEnterpriseId, enterpriseId);

        //通知企微好友
        log.info("通知会员 更新为企微好友 memberId:{}", memberId);
        memberApiService.updateMemberQywxFlag(enterpriseId, memberId, 1);
        return "";
    }

    /**
     * 同步
     *
     * @param wxEnterpriseId
     * @param enterpriseId
     */
    private void pushTagSync(String dataId, String taskId, int syncType, int taskType, String wxEnterpriseId, String enterpriseId) {
        QywxTagSyncInfoPojo pojo = new QywxTagSyncInfoPojo();
        pojo.setDataId(dataId);
        pojo.setTaskId(taskId);
        pojo.setTaskType(taskType);
        //单个会员同步
        pojo.setSyncType(syncType);
        pojo.setWxEnterpriseId(wxEnterpriseId);
        pojo.setEnterpriseId(enterpriseId);
        GicMQClient clientInstance = GICMQClientUtil.getClientInstance();
        try {
            clientInstance.sendMessage("qywxTagSyncDeal", JSONObject.toJSONString(pojo));
        } catch (Exception e) {
            log.info("异常：{}", e);
        }
    }

    /**
     * 同步
     *
     * @param memberId
     * @param wxEnterpriseId
     * @param enterpriseId
     */
    private void pushTagSync(String memberId, String wxEnterpriseId, String enterpriseId) {
        this.pushTagSync(memberId, "-1", GicQywxSyncTypeEnum.SINGLE_WXENT_MEMNER_SYNC.getType(), QywxSyncTaskTypeEnum.MEMBER_SYNC.getType(), wxEnterpriseId, enterpriseId);
    }

    @Override
    public String addFriendExternal(ExternalUserDTO dto) {
        String wxUserId = dto.getWxUserId();
        String wxEnterpriseId = dto.getWxEnterpriseId();
        String name = StringUtils.isBlank(dto.getName()) ? "--" : dto.getName();
        String createTime = dto.getAddCreateTime();
        String externalUserId = dto.getExternalUserId();
        String storeId = dto.getStoreId();
        String enterpriseId = dto.getEnterpriseId();
        String staffId = dto.getStaffId();
        String avatar = dto.getAvatar();
        String clerkId = dto.getClerkId();
        String selfExternalUserId = dto.getSelfExternalUserId();
        if (StringUtils.isAnyBlank(wxUserId, selfExternalUserId, wxEnterpriseId, name, createTime, externalUserId, storeId, enterpriseId, staffId, clerkId)) {
            log.error("参数不对：{}", JSON.toJSONString(dto));
            return "参数不对";
        }
        String relationKey = SecureUtil.md5(staffId + externalUserId);
        MemberUnionidRelatedDTO exsitDTO = memberUnionRelatedService.getByWxUserIdAndSelfExternalUserId(wxUserId, wxEnterpriseId, dto.getSelfExternalUserId());
        String uuid = "";
        if (exsitDTO == null) {
            exsitDTO = new MemberUnionidRelatedDTO();
            exsitDTO.setAvatar(avatar);
            exsitDTO.setSelfExternalUserid(dto.getSelfExternalUserId());
            exsitDTO.setAddCreateTime(createTime);
            exsitDTO.setEnterpriseId(enterpriseId);
            exsitDTO.setExternalName(name);
            exsitDTO.setExternalUserid(externalUserId);
            exsitDTO.setWxEnterpriseId(wxEnterpriseId);
            exsitDTO.setWxUserId(wxUserId);
            uuid = memberUnionRelatedService.addMemberUnionidRelated(exsitDTO);
        } else {
            uuid = exsitDTO.getMemberUnionidRelatedId();
            exsitDTO.setAvatar(avatar);
            exsitDTO.setExternalUserid(externalUserId);
            exsitDTO.setAddCreateTime(createTime);
            exsitDTO.setSelfExternalUserid(dto.getSelfExternalUserId());
            exsitDTO.setExternalName(name);
            memberUnionRelatedService.update(exsitDTO);
        }

        List<TabHaobanExternalClerkRelated> clerkRelateds = externalClerkRelatedService.listByExTernalUseridAndWxUserIdAllStatus(wxEnterpriseId, externalUserId, wxUserId);
        if (CollectionUtils.isEmpty(clerkRelateds)) {
            TabHaobanExternalClerkRelated related = new TabHaobanExternalClerkRelated();
            related.setAddCreateTime(createTime);
            related.setClerkId(clerkId);
            related.setEnterpriseId(enterpriseId);
            related.setExternalName(name);
            related.setExternalUserId(externalUserId);
            related.setStaffId(staffId);
            related.setMemberUnionidRelatedId(uuid);
            related.setStoreId(storeId);
            related.setWxEnterpriseId(wxEnterpriseId);
            related.setWxUserId(wxUserId);
            related.setStatusFlag(3);
            related.setHeadUrl(dto.getAvatar());
            related.setRelationKey(relationKey);
            externalClerkRelatedService.insert(related);
        } else {
            TabHaobanExternalClerkRelated external = clerkRelateds.get(0);
            external.setMemberUnionidRelatedId(uuid);
            external.setExternalUserId(externalUserId);
            external.setExternalName(name);
            external.setStoreId(storeId);
            external.setEnterpriseId(enterpriseId);
            external.setClerkId(clerkId);
            external.setStaffId(staffId);
            external.setHeadUrl(dto.getAvatar());
            external.setRelationKey(relationKey);
            external.setStatusFlag(external.getStatusFlag() == 1 ? 1 : external.getStatusFlag());
            externalClerkRelatedService.update(external);
        }
        return "";
    }

    @Override
    public void cleanNoExsitFriendNew(String wxEnterpriseId, String wxUserId, List<String> externalUserIds) {
        log.info("【清除不存在的好友】wxEnterpriseId={},wxUserId={}", wxEnterpriseId, wxUserId);
        //查询所有的外部联系人
        List<TabHaobanExternalClerkRelated> list = externalClerkRelatedMapper.getByWxUserIdAndWxEnterpriseId(wxEnterpriseId, wxUserId);
        if (CollectionUtils.isEmpty(list)) {
            log.info("改导购下没有外部联系人，无需清理外部联系人：{},{}", wxUserId, wxEnterpriseId);
            return;
        }
        Set<String> externalUserIdList = list.stream().map(external -> external.getExternalUserId()).collect(Collectors.toSet());
        Sets.SetView<String> delExternalUserIds = Sets.difference(new HashSet<>(externalUserIds), externalUserIdList);
        if (CollectionUtils.isEmpty(delExternalUserIds)) {
            log.info("没有需要删除逇外部联系人:{},{}", wxUserId, wxEnterpriseId);
            return;
        }
        //删除成员与union的关联关系
        memberUnionRelatedService.delMemberUnionidRelatedBatch(wxEnterpriseId, wxUserId, new ArrayList<>(delExternalUserIds));
        //删除导购和外部联系人关系
        externalClerkRelatedService.delByUserIdAndExternalUserIdBatch(wxEnterpriseId, wxUserId, new ArrayList<>(delExternalUserIds));
    }

    @Override
    public ServiceResponse<List<FriendStoreInfoDTO>> listFriendClerkByMemberUnionid(String enterpriseId, String unionId) {
        ServiceResponse<List<FriendStoreInfoDTO>> resp = new ServiceResponse<>();
        if (StringUtils.isAnyBlank(enterpriseId, unionId)) {
            resp.setMessage("参数有误");
            resp.setCode(2);
            return resp;
        }
        List<TabHaobanExternalClerkRelated> relateds = externalClerkRelatedService.listExternalByUnionId(enterpriseId, unionId);
        if (CollectionUtils.isEmpty(relateds)) {
            return resp;
        }
        //导购信息
        Set<String> clerkIds = relateds.stream().map(dto -> dto.getClerkId()).collect(Collectors.toSet());
        log.info("获取clerkIds：{}", JSONObject.toJSONString(clerkIds));
        List<ClerkDTO> clerkDTOS = clerkService.getClerkByIds(clerkIds);
        if (CollectionUtils.isEmpty(clerkDTOS)) {
            log.info("没有有效的导购");
            return resp;
        }
        Map<String, ClerkDTO> clerkMap = clerkDTOS.stream().collect(Collectors.toMap(ClerkDTO::getClerkId, dto -> dto));

        //门店信息
        List<String> storeIds = relateds.stream().map(dto -> dto.getStoreId()).collect(Collectors.toList());
        log.info("门店storeIds：{}", JSONObject.toJSONString(storeIds));
        List<StoreDTO> storeDTOS = storeService.queryStore(storeIds);
        if (CollectionUtils.isEmpty(storeDTOS)) {
            log.info("没有关联的门店");
            return resp;
        }
        Map<String, StoreDTO> storeMap = storeDTOS.stream().collect(Collectors.toMap(StoreDTO::getStoreId, dto -> dto));

        //组装
        log.info("组装返回的好友导购信息:{}", unionId);
        List<FriendStoreInfoDTO> ret = relateds.stream().map(related -> {
            ClerkDTO clerkDTO = clerkMap.get(related.getClerkId());
            StoreDTO storeDTO = storeMap.get(related.getStoreId());

            FriendStoreInfoDTO friendStoreInfoDTO = new FriendStoreInfoDTO();
            friendStoreInfoDTO.setAddFriendTime(related.getAddCreateTime());
            friendStoreInfoDTO.setClerkId(related.getClerkId());
            friendStoreInfoDTO.setStoreId(related.getStoreId());
            friendStoreInfoDTO.setWxUserId(related.getWxUserId());
            friendStoreInfoDTO.setStoreCode(storeDTO != null ? storeDTO.getStoreCode() : null);
            friendStoreInfoDTO.setStoreName(storeDTO != null ? storeDTO.getStoreName() : null);
            friendStoreInfoDTO.setClerkCode(clerkDTO != null ? clerkDTO.getClerkCode() : null);
            friendStoreInfoDTO.setClerkName(clerkDTO != null ? clerkDTO.getClerkName() : null);
            friendStoreInfoDTO.setClerkPhoneNumber(clerkDTO != null ? clerkDTO.getPhoneNumber() : null);
            return friendStoreInfoDTO;
        }).collect(Collectors.toList());
        resp.setResult(ret);
        return resp;
    }

    @Override
    public MemberUnionidRelatedDTO getExternalUseridInfoBySelfExternalUserId(String wxEnterpriseId, String wxUserId, String selfExternalUserId) {
        return memberUnionRelatedService.getByWxUserIdAndSelfExternalUserId(wxUserId, wxEnterpriseId, selfExternalUserId);
    }

    @Override
    public MemberUnionidRelatedDTO getBySelfExternalUserId(String wxEnterpriseId, String selfExternalUserId) {
        return memberUnionRelatedService.getBySelfExternalUserId(wxEnterpriseId, selfExternalUserId);
    }

    @Override
    public void addMemberUnionidWechatAccount(String res) {
        log.info("通过查询unionid关联导购对外联系人id接口,res:{}", res);
        if (StringUtils.isBlank(res)) {
            log.info("通过查询unionid关联导购对外联系人id接口为空");
            return;
        }
        MemberUnionidWechatAccountQDTO memberUnionidWechatAccountQDTO = JSON.parseObject(res, MemberUnionidWechatAccountQDTO.class);
        String enterpriseId = memberUnionidWechatAccountQDTO.getEnterpriseId();
        String unionid = memberUnionidWechatAccountQDTO.getUnionid();
        String openId = memberUnionidWechatAccountQDTO.getOpenId();
        String memberId = memberUnionidWechatAccountQDTO.getMemberId();
        if (StringUtils.isAnyBlank(enterpriseId, unionid, openId, memberId)) {
            log.error("关注公共号-会员回调好办关联好友 有参数为空:enterpriseId:{},unionid:{},openId:{},memberId:{}", enterpriseId, unionid, openId, memberId);
            return;
        }
        List<TabHaobanWxEnterprise> tabHaobanWxEnterprises = wxEnterpriseRelatedService.listByEnterpriseId(enterpriseId);
        if (CollectionUtils.isEmpty(tabHaobanWxEnterprises)) {
            log.error("企业为空");
            return;
        }

        RRateLimiter rateLimiter = RedisUtil.getRedisClient().getRateLimiter("member:weChat:add:limit");
        // 每1小时产生9500个令牌
        rateLimiter.trySetRate(RateType.OVERALL, 9500, 1, RateIntervalUnit.HOURS);
        for (TabHaobanWxEnterprise tabHaobanWxEnterpris : tabHaobanWxEnterprises) {
            if (!rateLimiter.tryAcquire()) {
                log.error("请求unionidToExternalUserid3rd超过限制，丢入消息队列，重新消费");
                GicMQClient clientInstance = GICMQClientUtil.getClientInstance();
                try {
                    clientInstance.sendMessage("addMemberUnionidWechatAccountMq", res, 60 * 60);
                } catch (Exception e) {
                    log.info("addMemberUnionidWechatAccount 发送失败：{}", e.getMessage(), e);
                }
                return;
            }
            String corpid = tabHaobanWxEnterpris.getCorpid();
            String wxEnterpriseId = tabHaobanWxEnterpris.getWxEnterpriseId();
            List<UnionidToExternalUseridDTO> unionidToExternalUseridDTOS = qywxUserApiService.unionidToExternalUserid3rd(unionid, openId, corpid, config.getWxSuiteid());
            if (CollectionUtils.isEmpty(unionidToExternalUseridDTOS)) {
                log.error("请求unionidToExternalUserid3rd返回为空");
                return;
            }

            for (UnionidToExternalUseridDTO unionidToExternalUseridDTO : unionidToExternalUseridDTOS) {
                String externalUserid = unionidToExternalUseridDTO.getExternalUserid();
                List<ExternalUserDTO> externalUseridInfoList = getExternalUseridInfoList(wxEnterpriseId, externalUserid);
                if (CollectionUtils.isEmpty(externalUseridInfoList)) {
                    log.error("返回客户详情为空：wxEnterpriseId:{},externalUserid:{}", wxEnterpriseId, externalUserid);
                    break;
                }
                for (ExternalUserDTO externalUserDTO : externalUseridInfoList) {
                    String wxUserId = externalUserDTO.getWxUserId();
                    TabHaobanExternalClerkRelated externalClerkRelated = externalClerkRelatedMapper.getByEnterpriseIdAndExternalUserId(wxEnterpriseId, wxUserId, enterpriseId, externalUserid);
                    if (externalClerkRelated == null) {
                        log.info("查询不到好友wxEnterpriseId:{}, wxUserId:{}, enterpriseId:{}, externalUserid:{}", wxEnterpriseId, wxUserId, enterpriseId, externalUserid);
                        continue;
                    }
                    boolean flag = externalClerkRelatedApiService.bindMemberIdExternalById(externalClerkRelated.getExternalClerkRelatedId(), enterpriseId, memberId, unionid);
                    if (flag) {
                        //调用会员接口来自企微
                        memberStoreService.saveMemberStoreClerkRelation(memberId, externalClerkRelated.getStoreId(), externalClerkRelated.getClerkId(), "企微好友");
                    }
                }
            }
        }
    }

    @Override
    public void addMemberUnionidWechatAccountByClerk(String res) {
        log.info("关注公共号-会员回调好办关联好友请求参数：{}", res);
        if (StringUtils.isBlank(res)) {
            log.info("关注公共号-会员回调好办关联好友请求参数为空");
            return;
        }
        MemberUnionidWechatAccountQDTO memberUnionidWechatAccountQDTO = JSON.parseObject(res, MemberUnionidWechatAccountQDTO.class);
        String enterpriseId = memberUnionidWechatAccountQDTO.getEnterpriseId();
        String unionid = memberUnionidWechatAccountQDTO.getUnionid();
        String openId = memberUnionidWechatAccountQDTO.getOpenId();
        String memberId = memberUnionidWechatAccountQDTO.getMemberId();
        String sceneStr = memberUnionidWechatAccountQDTO.getSceneStr();
        if (StringUtils.isAnyBlank(enterpriseId, unionid, openId, memberId, sceneStr)) {
            log.error("关注公共号-会员回调好办关联好友，有参数为空:enterpriseId:{},unionid:{},openId:{},memberId:{},sceneStr:{}", enterpriseId, unionid, openId, memberId, sceneStr);
            return;
        }
        String[] s = sceneStr.split("_");
        String relationKey = s[1];
        TabHaobanExternalClerkRelated externalClerkRelated = externalClerkRelatedMapper.getByRelationKey(relationKey);
        if (externalClerkRelated == null) {
            log.error("关注公共号-会员回调好办关联好友,未查询到,relationKey：{}", relationKey);
            //重试5次
            Integer currentTimes = Convert.toInt(RedisUtil.getCache(relationKey), 0);
            if (currentTimes > MAX_TIMES) {
                log.error("关注公共号-会员回调好办关联好友重试超过最大次数，relationKey：{}", relationKey);
                return;
            }
            GicMQClient clientInstance = GICMQClientUtil.getClientInstance();
            try {
                clientInstance.sendMessage("addMemberUnionidWechatAccountByClerkMq", res, 180);
                RedisUtil.setCache(relationKey, currentTimes + 1, 2L, TimeUnit.HOURS);
            } catch (Exception e) {
                log.info("发送消息异常：{}", e.getMessage());
            }
            return;
        }
        externalClerkRelatedApiService.bindMemberIdExternalById(externalClerkRelated.getExternalClerkRelatedId(), enterpriseId, memberId, unionid);
    }

    @Override
    public MemberUnionidRelatedDTO getByWxUserIdAndUnionId(String wxEnterpriseId, String wxUserId, String unionid) {
        return memberUnionRelatedService.getByWxUserIdAndUnionId(wxEnterpriseId, wxUserId, unionid);
    }

    @Override
    public void updateSelfExternalUseridById(String selfExternalUserid, String memberUnionidRelatedId) {
        MemberUnionidRelatedDTO relatedDTO = new MemberUnionidRelatedDTO();
        relatedDTO.setMemberUnionidRelatedId(memberUnionidRelatedId);
        relatedDTO.setSelfExternalUserid(selfExternalUserid);
        memberUnionRelatedService.update(relatedDTO);
    }

    @Override
    public MemberUnionidRelatedDTO getById(String memberUnionidRelatedId) {
        MemberUnionidRelated memberUnionidRelated = memberUnionidRelatedMapper.selectByPrimaryKey(memberUnionidRelatedId);
        return EntityUtil.changeEntityNew(MemberUnionidRelatedDTO.class, memberUnionidRelated);
    }


    @Override
    public ServiceResponse updateNewUseridCorpid(String wxEnterpriseId) {
        String lockKey = "updateNewUseridCorpid_" + wxEnterpriseId;
        WxEnterpriseDTO wxEnterpriseDTO = wxEnterpriseService.selectById(wxEnterpriseId);
        ServiceResponse serviceResponse = new ServiceResponse();
        if (wxEnterpriseDTO == null) {
            serviceResponse.setCode(HaoBanErrCodeCommon.ERR_0.getCode());
            serviceResponse.setMessage("企微应用不存在");
            return serviceResponse;
        }

        TabHaobanWxApplication tabHaobanWxApplication = wxApplicationMapper.selectByWxEnterpriseIdAndApplicationType(wxEnterpriseId, 3);
        if (tabHaobanWxApplication == null) {
            serviceResponse.setCode(HaoBanErrCodeCommon.ERR_0.getCode());
            serviceResponse.setMessage("企微代开发应用不存在");
            return serviceResponse;
        }

        if (RedisUtil.isLocked(lockKey)) {
            log.info("redis锁，lockKey：{}", lockKey);
            String corpName = tabHaobanWxApplication.getCorpid();
            serviceResponse.setCode(HaoBanErrCodeCommon.ERR_0.getCode());
            serviceResponse.setMessage(corpName + "已经在转换中，请勿重复操作！");
            return serviceResponse;
        }

        SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(wxEnterpriseId, SecretTypeEnum.CUSTOMIZED_APP.getVal());
        if (secretSetting == null) {
            serviceResponse.setCode(HaoBanErrCodeCommon.ERR_0.getCode());
            serviceResponse.setMessage("代开发密钥不存在");
            return serviceResponse;
        }

        String corpid = tabHaobanWxApplication.getCorpid();

        RedisUtil.lock(lockKey, 2L, TimeUnit.HOURS, 0L);

        wxEnterpriseService.updateUseridFlagById(2, null, wxEnterpriseId);

        JSONObject jsonObject = new JSONObject();
        jsonObject.put("corpid", corpid);
        jsonObject.put("wxEnterpriseId", wxEnterpriseId);
        jsonObject.put("secret", secretSetting.getSecretVal());
        GicMQClient clientInstance = GICMQClientUtil.getClientInstance();
        try {
            clientInstance.sendMessage("updateNewUseridCorpidMq", jsonObject.toJSONString());
        } catch (Exception e) {
            log.info("企微转换id发送消息队列异常：{}", e.getMessage(), e);
        }
        serviceResponse.setCode(HaoBanErrCodeCommon.ERR_1.getCode());
        return serviceResponse;
    }

    @Override
    public void updateNewUseridCorpidMq(String params) {
        if (StringUtils.isBlank(params)) {
            log.error("传入为空");
            return;
        }
        log.info("转换corpid、userid start params:{}", params);
        JSONObject jsonObject = JSON.parseObject(params);
        String wxEnterpriseId = jsonObject.getString("wxEnterpriseId");
        String corpid = jsonObject.getString("corpid");
        String secret = jsonObject.getString("secret");

        // 限流器
        RRateLimiter rateLimiter = RedisUtil.getRedisClient().getRateLimiter("haoban:manage3:updateNewUseridCorpid:limit");
        // 每1秒产生5个令牌
        rateLimiter.trySetRate(RateType.OVERALL, 5, 1, RateIntervalUnit.SECONDS);
        BasePageInfo basePageInfo = new BasePageInfo();
        int pageNum = 1;
        while (true) {
            rateLimiter.acquire();
            basePageInfo.setPageNum(pageNum);
            basePageInfo.setPageSize(1000);
            Page<StaffDTO> staffDTOPage = staffService.getPageStaffIdsByWxEnterpriseId(wxEnterpriseId, basePageInfo);
            List<StaffDTO> staffDTOList = staffDTOPage.getResult();
            if (CollectionUtil.isEmpty(staffDTOList)) {
                break;
            }
            List<String> stringList = staffDTOList.stream().map(StaffDTO::getWxUserId).distinct().collect(Collectors.toList());
            List<QywxNewUseridDTO> qywxNewUseridDTOList = qywxUserApiService.getSelfUseridToOpenuserid(corpid, secret, stringList);
            if (CollectionUtils.isEmpty(qywxNewUseridDTOList)) {
                log.error("调用企微无权限");
                continue;
            }

            for (QywxNewUseridDTO qywxNewUseridDTO : qywxNewUseridDTOList) {
                String userid = qywxNewUseridDTO.getUserid();
                String openUserid = qywxNewUseridDTO.getOpen_userid();
                log.info("转换新的userid,userid:{},openUserid:{}", userid, openUserid);
                staffService.updateUserIdByUserId(wxEnterpriseId, openUserid, userid);
            }
            pageNum++;
        }

        //更新导购员工关联关系表
        staffClerkRelationService.updateUserIdByWxEnterpriseId(wxEnterpriseId);
        //更新员工部门关联关系表
        staffDepartmentRelatedService.updateUserIdByWxEnterpriseId(wxEnterpriseId);
        //更新好友关系表
        memberUnionRelatedService.updateUserIdByWxEnterpriseId(wxEnterpriseId);
        //更新会员好友关系表
        externalClerkRelatedService.updateUserIdByWxEnterpriseId(wxEnterpriseId);
        //更新自建外部联系人id
        memberUnionRelatedService.updateExternalUseridByWxEnterpriseId(wxEnterpriseId);
        log.info("转换corpid、userid end params:{}", params);
        //迁移完成
        updateUseridFlagById(wxEnterpriseId, corpid);
    }

    /**
     * 迁移完成
     *
     * @param wxEnterpriseId
     * @param corpid
     */
    private void updateUseridFlagById(String wxEnterpriseId, String corpid) {
        String serviceCorpid = config.getCorpid();
        String openCorpid = qywxUserApiService.toOpenCorpid(corpid, serviceCorpid);
        TabHaobanWxApplication tabHaobanWxApplication = wxApplicationMapper.selectByWxEnterpriseIdAndApplicationType(wxEnterpriseId, 3);
        if (tabHaobanWxApplication == null) {
            log.info("代开发应用不存在：{}", corpid);
            return;
        }
        String[] openidType = {"1", "3"};
        //调用完成接口
        boolean flag = qywxUserApiService.finishOpenidMigration(corpid, serviceCorpid, tabHaobanWxApplication.getAgentId(), openidType);
        if (flag) {
            wxApplicationMapper.updateCorpidById(tabHaobanWxApplication.getWxApplicationId(), openCorpid);
            wxEnterpriseService.updateUseridFlagById(1, null, wxEnterpriseId);
        } else {
            wxEnterpriseService.updateUseridFlagById(3, null, wxEnterpriseId);
        }
        String lockKey = "updateNewUseridCorpid_" + wxEnterpriseId;
        RedisUtil.unlock(lockKey);
    }


    /**
     * 获取客户详情列表
     *
     * @param wxEnterpriseId
     * @param externalUserId
     * @return
     */
    private List<ExternalUserDTO> getExternalUseridInfoList(String wxEnterpriseId, String externalUserId) {
        WxEnterpriseDTO wxEnterprise = wxEnterpriseService.selectById(wxEnterpriseId);
        if (wxEnterprise == null) {
            log.info("企业不存在");
            return null;
        }
        String uJ = qywxUserApiService.getExternalUseridInfo(wxEnterprise.getCorpid(), config.getWxSuiteid(), externalUserId);
        if (StringUtils.isBlank(uJ)) {
            log.info("好友不存在");
            return null;
        } else if ("1".equals(uJ)) {
            log.info("限制次数");
            throw new WxApiLimitException("getExternalUseridInfo接口次数限制");
        }
        String name = "";
        String createTime = "";
        String avatar = "";
        Integer friendType = 1;
        List<ExternalUserPojo> externalUserPojoList = new ArrayList<>();
        JSONObject jo = JSON.parseObject(uJ);
        String external_contact = jo.getString("external_contact");
        String uj_follow_user = jo.getString("follow_user");
        JSONObject jt = null;
        if (StringUtils.isNotBlank(external_contact)) {
            jt = JSON.parseObject(external_contact);
            name = EmojiFilterUtil.filterEmojiLast(jt.getString("name"), true);
            if (StringUtils.isBlank(name)) {
                name = "--";
            }
            friendType = jt.getInteger("type");
            avatar = jt.getString("avatar");
        }
        if (StringUtils.isNotBlank(uj_follow_user)) {
            JSONArray j = JSON.parseArray(uj_follow_user);
            String uj_userId = "";
            for (Object object : j) {
                ExternalUserPojo pojo = new ExternalUserPojo();
                String followJson = JSON.toJSONString(object);
                JSONObject follow = JSON.parseObject(followJson);
                uj_userId = follow.getString("userid");
                if (jt != null) {
                    externalUserId = jt.getString("external_userid");
                    createTime = follow.getString("createtime");
                }
                pojo.setExternalUserId(externalUserId);
                pojo.setName(name);
                pojo.setAddCreateTime(createTime);
                pojo.setWxEnterpriseId(wxEnterpriseId);
                pojo.setAvatar(avatar);
                pojo.setWxUserId(uj_userId);
                pojo.setFriendType(friendType);
                externalUserPojoList.add(pojo);
            }
        }
        return EntityUtil.changeEntityListByJSON(ExternalUserDTO.class, externalUserPojoList);
    }


}
